/* IMPORTANT: s necessari estar connectat amb l'usuari ECOLLADOF amb password 12345678 abans d'executar aquest script */
/* En aquest script es crearan les taules de la BD i el DW i tamb els ndexs, les seqncies                          */
/* i els disparadors de seqncies per a les claus principals autoincrementals                                         */ 

/***********************************************************/
/*            Eliminaci de les taules                     */
/***********************************************************/
DROP TABLE RESPONSABLE CASCADE CONSTRAINTS;
DROP TABLE NIVELLESTUDIS CASCADE CONSTRAINTS;
DROP TABLE COMPETENCIAPROFESSIONAL CASCADE CONSTRAINTS;
DROP TABLE SEU CASCADE CONSTRAINTS;
DROP TABLE COMERCIAL CASCADE CONSTRAINTS;
DROP TABLE CLIENT CASCADE CONSTRAINTS;
DROP TABLE PROCESCAPTACIO CASCADE CONSTRAINTS;
DROP TABLE CANDIDAT CASCADE CONSTRAINTS;
DROP TABLE ENTREVISTAINTERNA CASCADE CONSTRAINTS;
DROP TABLE PROCESSELECCIO CASCADE CONSTRAINTS;
DROP TABLE ENTREVISTAEXTERNA CASCADE CONSTRAINTS;
DROP TABLE VISITACOMERCIAL CASCADE CONSTRAINTS;
DROP TABLE PROPOSTACOMERCIAL CASCADE CONSTRAINTS;
DROP TABLE CANDIDATCOMPETENCIA CASCADE CONSTRAINTS;
DROP TABLE CANDIDATPROCESSEL CASCADE CONSTRAINTS;
DROP TABLE PROCESSELCOMPETENCIA CASCADE CONSTRAINTS;
DROP TABLE LOG CASCADE CONSTRAINTS;
DROP TABLE DWNUMENTI CASCADE CONSTRAINTS;
DROP TABLE DWPROCSELPOSITIUS CASCADE CONSTRAINTS;
DROP TABLE DWTOTCANDIDATS CASCADE CONSTRAINTS;
DROP TABLE DWIMPORTPROPACC CASCADE CONSTRAINTS;
DROP TABLE DWCOMMILLORRATIO CASCADE CONSTRAINTS;
DROP TABLE DWMILLORPROCCAP CASCADE CONSTRAINTS;
DROP TABLE DWTOTDEMESTUDIS CASCADE CONSTRAINTS;
DROP TABLE DWTOP10ESTUDIS CASCADE CONSTRAINTS;
DROP TABLE DWTOTDEMCOMPETENCIA CASCADE CONSTRAINTS;
DROP TABLE DWTOP5COMPETENCIA CASCADE CONSTRAINTS;
DROP TABLE DWCLIENTMESACC CASCADE CONSTRAINTS;
DROP TABLE DWDENEGCLIENTS CASCADE CONSTRAINTS;
DROP TABLE DWTOPDENEGCLIENT CASCADE CONSTRAINTS;
DROP TABLE DWVISITCOMERCIAL CASCADE CONSTRAINTS;
DROP TABLE DWCAPCANDCLIENTS CASCADE CONSTRAINTS;
DROP TABLE DWMENYSENTSEU CASCADE CONSTRAINTS;


/***********************************************************/
/*            Eliminaci de les seqncies                    */
/***********************************************************/
DROP SEQUENCE SEQRESPONSABLE;
DROP SEQUENCE SEQESTUDIS;
DROP SEQUENCE SEQCOMPETENCIA;
DROP SEQUENCE SEQSEU;
DROP SEQUENCE SEQCOMERCIAL;
DROP SEQUENCE SEQCLIENT;
DROP SEQUENCE SEQPROCESCAP;
DROP SEQUENCE SEQCANDIDAT;
DROP SEQUENCE SEQENTREVISTAI;
DROP SEQUENCE SEQPROCESSEL;
DROP SEQUENCE SEQENTREVISTAE;
DROP SEQUENCE SEQVISITA;
DROP SEQUENCE SEQPROPOSTA;
DROP SEQUENCE SEQLOG;

/* Totes les taules i els ndex es creen en el mateix tablespace anomenat RECRUITCAT_DATA */

/***********************************************************/
/*         1- Creaci de la taula RESPONSABLE              */
/***********************************************************/
CREATE TABLE RESPONSABLE 
(
  IDRESPONSABLE NUMBER(*, 0) NOT NULL 
, NOM NVARCHAR2(50) NOT NULL 
, ADRECA NVARCHAR2(50) 
, POBLACIO NVARCHAR2(50) 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;
-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXRESPONSABLE ON RESPONSABLE (IDRESPONSABLE ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE RESPONSABLE
ADD CONSTRAINT RESPONSABLE_PK PRIMARY KEY 
(
  IDRESPONSABLE 
)
USING INDEX INDEXRESPONSABLE
ENABLE;

/***********************************************************/
/*          2- Creaci de la taula NIVELLESTUDIS           */
/***********************************************************/
CREATE TABLE NIVELLESTUDIS 
(
  IDESTUDIS NUMBER(*, 0) NOT NULL 
, DESCRIPCIO VARCHAR2(50 BYTE) NOT NULL 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXESTUDIS ON NIVELLESTUDIS (IDESTUDIS ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE NIVELLESTUDIS
ADD CONSTRAINT NIVELLESTUDIS_PK PRIMARY KEY 
(
  IDESTUDIS 
)
USING INDEX INDEXESTUDIS
ENABLE;


/***********************************************************/
/*         3- Creaci de la taula COMPETENCIAPROFESSIONAL  */
/***********************************************************/
CREATE TABLE COMPETENCIAPROFESSIONAL 
(
  IDCOMPETENCIA NUMBER(*, 0) NOT NULL 
, DESCRIPCIO VARCHAR2(50 BYTE) NOT NULL 
, DATACREACIO DATE NOT NULL 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXCOMPETENCIA ON COMPETENCIAPROFESSIONAL (IDCOMPETENCIA ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE COMPETENCIAPROFESSIONAL
ADD CONSTRAINT COMPETENCIAPROFESSIONAL_PK PRIMARY KEY 
(
  IDCOMPETENCIA 
)
USING INDEX INDEXCOMPETENCIA
ENABLE;

/***********************************************************/
/*         4- Creaci de la taula SEU                      */
/***********************************************************/
CREATE TABLE SEU 
(
  IDSEU NUMBER(*, 0) NOT NULL 
, FIDRESPONSABLE NUMBER(*, 0) NOT NULL 
, POBLACIO NVARCHAR2(50) 
, CODIPOSTAL VARCHAR2(5 BYTE) 
, ADRECA NVARCHAR2(50) 
, DATAINAUGURACIO DATE NOT NULL 
, DATABAIXA DATE DEFAULT NULL 
, NUMENTANYACTUAL NUMBER(*, 0) DEFAULT 0 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXSEU ON SEU (IDSEU ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE SEU
ADD CONSTRAINT SEU_PK PRIMARY KEY 
(
  IDSEU 
)
USING INDEX INDEXSEU
ENABLE;

-- Definici de clau forana 
ALTER TABLE SEU
ADD CONSTRAINT SEU_FK1 FOREIGN KEY
(
  FIDRESPONSABLE 
)
REFERENCES RESPONSABLE
(
  IDRESPONSABLE 
)
ENABLE;

/***********************************************************/
/*         5- Creaci de la taula COMERCIAL                */
/***********************************************************/
CREATE TABLE COMERCIAL 
(
  IDCOMERCIAL NUMBER(*, 0) NOT NULL 
, FIDSEU NUMBER(*, 0) NOT NULL 
, NOM NVARCHAR2(50) NOT NULL 
, ADRECA NVARCHAR2(50) 
, POBLACIO NVARCHAR2(50) 
, DATABAIXA DATE DEFAULT NULL 
, NUMPRESENTADES NUMBER(*, 0) DEFAULT 0 
, NUMACCEPTADES NUMBER(*, 0) DEFAULT 0 
, VISITESANYACTUAL NUMBER(*, 0) DEFAULT 0 
, RATIO NUMBER AS ( CASE  WHEN "NUMPRESENTADES"<>0 THEN "NUMACCEPTADES"/"NUMPRESENTADES" ELSE 0 END ) VIRTUAL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXCOMERCIAL ON COMERCIAL (IDCOMERCIAL ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE COMERCIAL
ADD CONSTRAINT COMERCIAL_PK PRIMARY KEY 
(
  IDCOMERCIAL 
)
USING INDEX INDEXCOMERCIAL
ENABLE;

-- Definici de clau forana
ALTER TABLE COMERCIAL
ADD CONSTRAINT COMERCIAL_FK1 FOREIGN KEY
(
  FIDSEU 
)
REFERENCES SEU
(
  IDSEU 
)
ENABLE;

/***********************************************************/
/*         6- Creaci de la taula CLIENT                   */
/***********************************************************/
CREATE TABLE CLIENT 
(
  IDCLIENT NUMBER(*, 0) NOT NULL 
, FIDSEU NUMBER(*, 0) NOT NULL 
, FIDCOMERCIAL NUMBER(*, 0) NOT NULL 
, NOM NVARCHAR2(50) NOT NULL 
, ADRECA NVARCHAR2(50) 
, POBLACIO NVARCHAR2(50) 
, DATABAIXA DATE DEFAULT NULL 
, NUMCANDACCEPTATS NUMBER(*, 0) DEFAULT 0 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXCLIENT ON CLIENT (IDCLIENT ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE CLIENT
ADD CONSTRAINT CLIENT_PK PRIMARY KEY 
(
  IDCLIENT 
)
USING INDEX INDEXCLIENT
ENABLE;

-- Definici de clau forana
ALTER TABLE CLIENT
ADD CONSTRAINT CLIENT_FK1 FOREIGN KEY
(
  FIDSEU 
)
REFERENCES SEU
(
  IDSEU 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE CLIENT
ADD CONSTRAINT CLIENT_FK2 FOREIGN KEY
(
  FIDCOMERCIAL 
)
REFERENCES COMERCIAL
(
  IDCOMERCIAL 
)
ENABLE;

/***********************************************************/
/*         7- Creaci de la taula PROCESCAPTACIO           */
/***********************************************************/
CREATE TABLE PROCESCAPTACIO 
(
  IDPROCESCAP NUMBER(*, 0) NOT NULL 
, TIPUS NVARCHAR2(20) NOT NULL 
, DATAINICI DATE NOT NULL 
, DATABAIXA DATE DEFAULT NULL 
, NUMACCPROCSEL NUMBER(*, 0) DEFAULT 0 
, NUMSELCLIENTANYACTUAL NUMBER(*, 0) DEFAULT 0 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXPROCESCAP ON PROCESCAPTACIO (IDPROCESCAP ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE PROCESCAPTACIO
ADD CONSTRAINT PROCESCAPTACIO_PK PRIMARY KEY 
(
  IDPROCESCAP 
)
USING INDEX INDEXPROCESCAP
ENABLE;

/***********************************************************/
/*         8- Creaci de la taula CANDIDAT                 */
/***********************************************************/
CREATE TABLE CANDIDAT 
(
  IDCANDIDAT NUMBER(*, 0) NOT NULL 
, FIDSEU NUMBER(*, 0) NOT NULL 
, FIDPROCESCAP NUMBER(*, 0) NOT NULL 
, FIDESTUDIS NUMBER(*, 0) NOT NULL 
, NOM NVARCHAR2(50) NOT NULL 
, DATANAIXEMENT DATE NOT NULL 
, DATABAIXA DATE DEFAULT NULL 
, NUMPROCESSEL NUMBER(*, 0) DEFAULT 0 
, MOBILITAT CHAR(1 BYTE) DEFAULT 'N' 
, SELCLIENT CHAR(1 BYTE) DEFAULT 'N' 
-- Definici de clau principal
, CONSTRAINT CANDIDAT_PK PRIMARY KEY 
  (
    IDCANDIDAT 
  )
  USING INDEX 
  (
      -- Creaci de l'ndex per a la clau principal
      CREATE UNIQUE INDEX INDEXCANDIDAT ON CANDIDAT (IDCANDIDAT ASC) 
      LOGGING 
      TABLESPACE RECRUITCAT_DATA 
      PCTFREE 10 
      INITRANS 2 
      STORAGE 
      ( 
        INITIAL 65536 
        NEXT 1048576 
        MINEXTENTS 1 
        MAXEXTENTS UNLIMITED 
        BUFFER_POOL DEFAULT 
      ) 
      NOPARALLEL 
  )
  ENABLE 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau forana
ALTER TABLE CANDIDAT
ADD CONSTRAINT CANDIDAT_FK1 FOREIGN KEY
(
  FIDSEU 
)
REFERENCES SEU
(
  IDSEU 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE CANDIDAT
ADD CONSTRAINT CANDIDAT_FK2 FOREIGN KEY
(
  FIDPROCESCAP 
)
REFERENCES PROCESCAPTACIO
(
  IDPROCESCAP 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE CANDIDAT
ADD CONSTRAINT CANDIDAT_FK3 FOREIGN KEY
(
  FIDESTUDIS 
)
REFERENCES NIVELLESTUDIS
(
  IDESTUDIS 
)
ENABLE;

-- valors permesos en el camp mobilitat
ALTER TABLE CANDIDAT
ADD CONSTRAINT CANDIDAT_CHK1 CHECK 
(MOBILITAT IN ('S','N'))
ENABLE;

-- valors permesos en el camp selclient
ALTER TABLE CANDIDAT
ADD CONSTRAINT CANDIDAT_CHK2 CHECK 
(SELCLIENT IN ('S','N'))
ENABLE;

/***********************************************************/
/*         9- Creaci de la taula ENTREVISTAINTERNA        */
/***********************************************************/
CREATE TABLE ENTREVISTAINTERNA 
(
  IDENTREVISTAI NUMBER(*, 0) NOT NULL 
, FIDSEU NUMBER(*, 0) NOT NULL 
, FIDCANDIDAT NUMBER(*, 0) NOT NULL 
, DATA DATE NOT NULL 
, RESULTAT CHAR(1 BYTE) DEFAULT NULL 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXENTREVISTAI ON ENTREVISTAINTERNA (IDENTREVISTAI ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE ENTREVISTAINTERNA
ADD CONSTRAINT ENTREVISTAINTERNA_PK PRIMARY KEY 
(
  IDENTREVISTAI 
)
USING INDEX INDEXENTREVISTAI
ENABLE;

-- Definici de clau forana
ALTER TABLE ENTREVISTAINTERNA
ADD CONSTRAINT ENTREVISTAINTERNA_FK1 FOREIGN KEY
(
  FIDSEU 
)
REFERENCES SEU
(
  IDSEU 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE ENTREVISTAINTERNA
ADD CONSTRAINT ENTREVISTAINTERNA_FK2 FOREIGN KEY
(
  FIDCANDIDAT 
)
REFERENCES CANDIDAT
(
  IDCANDIDAT 
)
ENABLE;

-- valors permesos en el camp resultat
ALTER TABLE ENTREVISTAINTERNA
ADD CONSTRAINT ENTREVISTAINTERNA_CHK1 CHECK 
(RESULTAT IN ('P','N'))
ENABLE;

/***********************************************************/
/*         10- Creaci de la taula PROCESSELECCIO          */
/***********************************************************/
CREATE TABLE PROCESSELECCIO 
(
  IDPROCESSEL NUMBER(*, 0) NOT NULL 
, FIDCLIENT NUMBER(*, 0) NOT NULL 
, FIDESTUDIS NUMBER(*, 0) NOT NULL 
, DATAINICI DATE NOT NULL 
, DATAFI DATE 
, RESULTAT CHAR(1 BYTE) DEFAULT NULL 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXPROCESSEL ON PROCESSELECCIO (IDPROCESSEL ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE PROCESSELECCIO
ADD CONSTRAINT PROCESSELECCIO_PK PRIMARY KEY 
(
  IDPROCESSEL 
)
USING INDEX INDEXPROCESSEL
ENABLE;

-- Definici de clau forana
ALTER TABLE PROCESSELECCIO
ADD CONSTRAINT PROCESSELECCIO_FK1 FOREIGN KEY
(
  FIDCLIENT 
)
REFERENCES CLIENT
(
  IDCLIENT 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE PROCESSELECCIO
ADD CONSTRAINT PROCESSELECCIO_FK2 FOREIGN KEY
(
  FIDESTUDIS 
)
REFERENCES NIVELLESTUDIS
(
  IDESTUDIS 
)
ENABLE;

-- Valors permesos en el camp resultat
ALTER TABLE PROCESSELECCIO
ADD CONSTRAINT PROCESSELECCIO_CHK1 CHECK 
(RESULTAT IN ('P','N'))
ENABLE;


/***********************************************************/
/*         11- Creaci de la taula ENTREVISTAEXTERNA       */
/***********************************************************/

CREATE TABLE ENTREVISTAEXTERNA 
(
  IDENTREVISTAE NUMBER(*, 0) NOT NULL 
, FIDCLIENT NUMBER(*, 0) NOT NULL 
, FIDCANDIDAT NUMBER(*, 0) NOT NULL 
, FIDPROCESSEL NUMBER(*, 0) NOT NULL 
, DATA DATE NOT NULL 
, RESULTAT CHAR(1 BYTE) DEFAULT NULL 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXENTREVISTAE ON ENTREVISTAEXTERNA (IDENTREVISTAE ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE ENTREVISTAEXTERNA
ADD CONSTRAINT ENTREVISTAEXTERNA_PK PRIMARY KEY 
(
  IDENTREVISTAE 
)
USING INDEX INDEXENTREVISTAE
ENABLE;

-- Definici de clau forana
ALTER TABLE ENTREVISTAEXTERNA
ADD CONSTRAINT ENTREVISTAEXTERNA_FK1 FOREIGN KEY
(
  FIDCLIENT 
)
REFERENCES CLIENT
(
  IDCLIENT 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE ENTREVISTAEXTERNA
ADD CONSTRAINT ENTREVISTAEXTERNA_FK2 FOREIGN KEY
(
  FIDCANDIDAT 
)
REFERENCES CANDIDAT
(
  IDCANDIDAT 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE ENTREVISTAEXTERNA
ADD CONSTRAINT ENTREVISTAEXTERNA_FK3 FOREIGN KEY
(
  FIDPROCESSEL 
)
REFERENCES PROCESSELECCIO
(
  IDPROCESSEL 
)
ENABLE;

-- valors permesos en el camp resultat
ALTER TABLE ENTREVISTAEXTERNA
ADD CONSTRAINT ENTREVISTAEXTERNA_CHK1 CHECK 
(RESULTAT IN ('P','N','R'))
ENABLE;

/***********************************************************/
/*         12- Creaci de la taula VISITACOMERCIAL       */
/***********************************************************/

CREATE TABLE VISITACOMERCIAL 
(
  IDVISITA NUMBER(*, 0) NOT NULL 
, FIDCOMERCIAL NUMBER(*, 0) NOT NULL 
, FIDCLIENT NUMBER(*, 0) NOT NULL 
, DATAVISITA DATE NOT NULL 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXVISITA ON VISITACOMERCIAL (IDVISITA ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE VISITACOMERCIAL
ADD CONSTRAINT VISITACOMERCIAL_PK PRIMARY KEY 
(
  IDVISITA 
)
USING INDEX INDEXVISITA
ENABLE;

-- Definici de clau forana
ALTER TABLE VISITACOMERCIAL
ADD CONSTRAINT VISITACOMERCIAL_FK1 FOREIGN KEY
(
  FIDCOMERCIAL 
)
REFERENCES COMERCIAL
(
  IDCOMERCIAL 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE VISITACOMERCIAL
ADD CONSTRAINT VISITACOMERCIAL_FK2 FOREIGN KEY
(
  FIDCLIENT 
)
REFERENCES CLIENT
(
  IDCLIENT 
)
ENABLE;

/***********************************************************/
/*         13- Creaci de la taula PROPOSTACOMERCIAL       */
/***********************************************************/

CREATE TABLE PROPOSTACOMERCIAL 
(
  IDPROPOSTA NUMBER(*, 0) NOT NULL 
, FIDCOMERCIAL NUMBER(*, 0) NOT NULL 
, FIDCLIENT NUMBER(*, 0) NOT NULL 
, IMPORT FLOAT(126) NOT NULL 
, DATAPROPOSTA DATE NOT NULL 
, ESTAT CHAR(1 BYTE) DEFAULT NULL 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXPROPOSTA ON PROPOSTACOMERCIAL (IDPROPOSTA ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE PROPOSTACOMERCIAL
ADD CONSTRAINT PROPOSTACOMERCIAL_PK PRIMARY KEY 
(
  IDPROPOSTA 
)
USING INDEX INDEXPROPOSTA
ENABLE;

-- Definici de clau forana
ALTER TABLE PROPOSTACOMERCIAL
ADD CONSTRAINT PROPOSTACOMERCIAL_FK1 FOREIGN KEY
(
  FIDCOMERCIAL 
)
REFERENCES COMERCIAL
(
  IDCOMERCIAL 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE PROPOSTACOMERCIAL
ADD CONSTRAINT PROPOSTACOMERCIAL_FK2 FOREIGN KEY
(
  FIDCLIENT 
)
REFERENCES CLIENT
(
  IDCLIENT 
)
ENABLE;

-- valors permesos per al camp estat
ALTER TABLE PROPOSTACOMERCIAL
ADD CONSTRAINT PROPOSTACOMERCIAL_CHK1 CHECK 
(ESTAT IN ('A','R'))
ENABLE;


/***********************************************************/
/*         14- Creaci de la taula CANDIDATCOMPETENCIA     */
/***********************************************************/
CREATE TABLE CANDIDATCOMPETENCIA 
(
  FIDCANDIDAT NUMBER(*, 0) NOT NULL 
, FIDCOMPETENCIA NUMBER(*, 0) NOT NULL 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXCANDIDATCOMPETENCIA ON CANDIDATCOMPETENCIA (FIDCANDIDAT ASC, FIDCOMPETENCIA ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE CANDIDATCOMPETENCIA
ADD CONSTRAINT CANDIDATCOMPETENCIA_PK PRIMARY KEY 
(
  FIDCANDIDAT 
, FIDCOMPETENCIA 
)
USING INDEX INDEXCANDIDATCOMPETENCIA
ENABLE;

-- Definici de clau forana
ALTER TABLE CANDIDATCOMPETENCIA
ADD CONSTRAINT CANDIDATCOMPETENCIA_FK1 FOREIGN KEY
(
  FIDCANDIDAT 
)
REFERENCES CANDIDAT
(
  IDCANDIDAT 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE CANDIDATCOMPETENCIA
ADD CONSTRAINT CANDIDATCOMPETENCIA_FK2 FOREIGN KEY
(
  FIDCOMPETENCIA 
)
REFERENCES COMPETENCIAPROFESSIONAL
(
  IDCOMPETENCIA 
)
ENABLE;

/***********************************************************/
/*         15- Creaci de la taula CANDIDATPROCESSEL       */
/***********************************************************/
CREATE TABLE CANDIDATPROCESSEL 
(
  FIDCANDIDAT NUMBER(*, 0) NOT NULL 
, FIDPROCESSEL NUMBER(*, 0) NOT NULL 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXCANDIDATPROCESSEL ON CANDIDATPROCESSEL (FIDCANDIDAT ASC, FIDPROCESSEL ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE CANDIDATPROCESSEL
ADD CONSTRAINT CANDIDATPROCESSEL_PK PRIMARY KEY 
(
  FIDCANDIDAT 
, FIDPROCESSEL 
)
USING INDEX INDEXCANDIDATPROCESSEL
ENABLE;

-- Definici de clau forana
ALTER TABLE CANDIDATPROCESSEL
ADD CONSTRAINT CANDIDATPROCESSEL_FK1 FOREIGN KEY
(
  FIDCANDIDAT 
)
REFERENCES CANDIDAT
(
  IDCANDIDAT 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE CANDIDATPROCESSEL
ADD CONSTRAINT CANDIDATPROCESSEL_FK2 FOREIGN KEY
(
  FIDPROCESSEL 
)
REFERENCES PROCESSELECCIO
(
  IDPROCESSEL 
)
ENABLE;

/***********************************************************/
/*         16- Creaci de la taula PROCESSELCOMPETENCIA    */
/***********************************************************/
CREATE TABLE PROCESSELCOMPETENCIA 
(
  FIDPROCESSEL NUMBER(*, 0) NOT NULL 
, FIDCOMPETENCIA NUMBER(*, 0) NOT NULL 
, DATABAIXA DATE DEFAULT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXPROCESSELCOMP ON PROCESSELCOMPETENCIA (FIDPROCESSEL ASC, FIDCOMPETENCIA ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE PROCESSELCOMPETENCIA
ADD CONSTRAINT PROCESSELCOMPETENCIA_PK PRIMARY KEY 
(
  FIDPROCESSEL 
, FIDCOMPETENCIA 
)
USING INDEX INDEXPROCESSELCOMP
ENABLE;

-- Definici de clau forana
ALTER TABLE PROCESSELCOMPETENCIA
ADD CONSTRAINT PROCESSELCOMPETENCIA_FK1 FOREIGN KEY
(
  FIDPROCESSEL 
)
REFERENCES PROCESSELECCIO
(
  IDPROCESSEL 
)
ENABLE;

-- Definici de clau forana
ALTER TABLE PROCESSELCOMPETENCIA
ADD CONSTRAINT PROCESSELCOMPETENCIA_FK2 FOREIGN KEY
(
  FIDCOMPETENCIA 
)
REFERENCES COMPETENCIAPROFESSIONAL
(
  IDCOMPETENCIA 
)
ENABLE;


/***********************************************************/
/*         17- Creaci de la taula LOG                     */
/***********************************************************/
CREATE TABLE LOG 
(
  IDLOG NUMBER(*, 0) NOT NULL 
, NOMPROCEDIMENT NVARCHAR2(50) NOT NULL 
, PARAMENTRADA NVARCHAR2(255) 
, RSP NVARCHAR2(255) NOT NULL 
, DATAEXECUCIO DATE NOT NULL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE
UNIQUE INDEX INDEXLOG ON LOG (IDLOG ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE LOG
ADD CONSTRAINT LOG_PK PRIMARY KEY 
(
  IDLOG 
)
USING INDEX INDEXLOG
ENABLE;

/***********************************************************/
/*         18- Creaci de la taula DWNUMENTI               */
/***********************************************************/
CREATE TABLE DWNUMENTI 
(
  ANYO NUMBER(*, 0) NOT NULL 
, NUMENTREVISTESI NUMBER(*, 0) DEFAULT 0 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXNUMENTI ON DWNUMENTI (ANYO ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE DWNUMENTI
ADD CONSTRAINT DWNUMENTI_PK PRIMARY KEY 
(
  ANYO 
)
USING INDEX INDEXNUMENTI
ENABLE;


/***********************************************************/
/*         19- Creaci de la taula DWPROCSELPOSITIUS       */
/***********************************************************/
CREATE TABLE DWPROCSELPOSITIUS 
(
  ANYO NUMBER(*, 0) NOT NULL 
, NUMPROCESSOS NUMBER(*, 0) DEFAULT 0 
, NUMPOSITIUS NUMBER(*, 0) DEFAULT 0 
, PERCPOSITIUS NUMBER AS ( CASE  WHEN "NUMPROCESSOS"<>0 THEN "NUMPOSITIUS"/"NUMPROCESSOS"*100 ELSE 0 END ) VIRTUAL 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXPROCSELPOSITIUS ON DWPROCSELPOSITIUS (ANYO ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE DWPROCSELPOSITIUS
ADD CONSTRAINT DWPROCSELPOSITIUS_PK PRIMARY KEY 
(
  ANYO 
)
USING INDEX INDEXPROCSELPOSITIUS
ENABLE;

/***********************************************************/
/*         20- Creaci de la taula DWTOTCANDIDATS          */
/***********************************************************/
CREATE TABLE DWTOTCANDIDATS 
(
  IDTOTCANDIDATS NUMBER(*, 0) DEFAULT 1 NOT NULL 
, TOTALCANDIDATS NUMBER(*, 0) DEFAULT 0 
, TOTALSELPROCES NUMBER(*, 0) DEFAULT 0 
, TOTALSELCLIENT NUMBER(*, 0) DEFAULT 0 
, PERNOSELPROCES NUMBER AS ( CASE  WHEN "TOTALCANDIDATS"<>0 THEN 100-"TOTALSELPROCES"/"TOTALCANDIDATS"*100 ELSE 0 END ) VIRTUAL 
, PERNOSELCLIENT NUMBER AS ( CASE  WHEN "TOTALCANDIDATS"<>0 THEN 100-"TOTALSELCLIENT"/"TOTALCANDIDATS"*100 ELSE 0 END ) VIRTUAL 
-- Definici de clau principal
, CONSTRAINT DWTOTCANDIDATS_PK PRIMARY KEY 
  (
    IDTOTCANDIDATS 
  )
  USING INDEX 
  (
      -- Creaci de l'ndex per a la clau principal
      CREATE UNIQUE INDEX DWTOTCANDIDATS_PK ON DWTOTCANDIDATS (IDTOTCANDIDATS ASC) 
      LOGGING 
      TABLESPACE RECRUITCAT_DATA 
      PCTFREE 10 
      INITRANS 2 
      STORAGE 
      ( 
        INITIAL 65536 
        NEXT 1048576 
        MINEXTENTS 1 
        MAXEXTENTS UNLIMITED 
        BUFFER_POOL DEFAULT 
      ) 
      NOPARALLEL 
  )
  ENABLE 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;


/***********************************************************/
/*         21- Creaci de la taula DWIMPORTPROPACC         */
/***********************************************************/
CREATE TABLE DWIMPORTPROPACC 
(
  ANYO NUMBER(*, 0) NOT NULL 
, IMPORTACCEPTADES FLOAT(126) DEFAULT 0 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXIMPORTPROPACC ON DWIMPORTPROPACC (ANYO ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE DWIMPORTPROPACC
ADD CONSTRAINT DWIMPORTPROPACC_PK PRIMARY KEY 
(
  ANYO 
)
USING INDEX INDEXIMPORTPROPACC
ENABLE;


/***********************************************************/
/*         22- Creaci de la taula DWCOMMILLORRATIO        */
/***********************************************************/
CREATE TABLE DWCOMMILLORRATIO 
(
  IDCOMMILLORRATIO NUMBER(*, 0) DEFAULT 1 NOT NULL 
, NOMCOMERCIAL NVARCHAR2(50) NOT NULL 
, RATIO FLOAT(126) DEFAULT 0 
-- Definici de clau principal
, CONSTRAINT DWCOMMILLORRATIO_PK PRIMARY KEY 
  (
    IDCOMMILLORRATIO 
  )
  USING INDEX 
  (
      -- Creaci de l'ndex per a la clau principal
      CREATE UNIQUE INDEX DWCOMMILLORRATIO_PK ON DWCOMMILLORRATIO (IDCOMMILLORRATIO ASC) 
      LOGGING 
      TABLESPACE RECRUITCAT_DATA 
      PCTFREE 10 
      INITRANS 2 
      STORAGE 
      ( 
        INITIAL 65536 
        NEXT 1048576 
        MINEXTENTS 1 
        MAXEXTENTS UNLIMITED 
        BUFFER_POOL DEFAULT 
      ) 
      NOPARALLEL 
  )
  ENABLE 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;


/***********************************************************/
/*         23- Creaci de la taula DWMILLORPROCCAP         */
/***********************************************************/
CREATE TABLE DWMILLORPROCCAP 
(
  IDMILLORPROCCAP NUMBER(*, 0) DEFAULT 1 NOT NULL 
, TIPUS NVARCHAR2(50) 
, TOTALPROCESSEL NUMBER(*, 0) 
-- Definici de clau principal
, CONSTRAINT DWMILLORPROCCAP_PK PRIMARY KEY 
  (
    IDMILLORPROCCAP 
  )
  USING INDEX 
  (
      -- Creaci de l'ndex per a la clau principal
      CREATE UNIQUE INDEX DWMILLORPROCCAP_PK ON DWMILLORPROCCAP (IDMILLORPROCCAP ASC) 
      LOGGING 
      TABLESPACE RECRUITCAT_DATA 
      PCTFREE 10 
      INITRANS 2 
      STORAGE 
      ( 
        INITIAL 65536 
        NEXT 1048576 
        MINEXTENTS 1 
        MAXEXTENTS UNLIMITED 
        BUFFER_POOL DEFAULT 
      ) 
      NOPARALLEL 
  )
  ENABLE 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

/***********************************************************/
/*         24- Creaci de la taula DWTOTDEMESTUDIS         */
/***********************************************************/
CREATE TABLE DWTOTDEMESTUDIS 
(
  ANYO NUMBER(*, 0) NOT NULL 
, FIDESTUDIS NUMBER(*, 0) NOT NULL 
, TIPUS NVARCHAR2(50) 
, TOTALDEMANATSPROCES NUMBER(*, 0) DEFAULT 0 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXTOTDEMESTUDIS ON DWTOTDEMESTUDIS (ANYO ASC, FIDESTUDIS ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE DWTOTDEMESTUDIS
ADD CONSTRAINT DWTOTDEMESTUDIS_PK PRIMARY KEY 
(
  ANYO 
, FIDESTUDIS 
)
USING INDEX INDEXTOTDEMESTUDIS
ENABLE;

/***********************************************************/
/*         25- Creaci de la taula DWTOP10ESTUDIS          */
/***********************************************************/
CREATE TABLE DWTOP10ESTUDIS 
(
  ANYO NUMBER(*, 0) NOT NULL 
, TIPUS NVARCHAR2(50) NOT NULL 
, TOTAL NUMBER(*, 0) DEFAULT 0 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXTOP10ESTUDIS ON DWTOP10ESTUDIS (ANYO ASC, TIPUS ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE DWTOP10ESTUDIS
ADD CONSTRAINT DWTOP10ESTUDIS_PK PRIMARY KEY 
(
  ANYO 
, TIPUS 
)
USING INDEX INDEXTOP10ESTUDIS
ENABLE;



/***********************************************************/
/*         26- Creaci de la taula DWTOTDEMCOMPETENCIA     */
/***********************************************************/
CREATE TABLE DWTOTDEMCOMPETENCIA 
(
  ANYO NUMBER(*, 0) NOT NULL 
, FIDCOMPETENCIA NUMBER(*, 0) NOT NULL 
, DESCRIPCIO NVARCHAR2(50) 
, TOTALDEMANATSPROCES NUMBER(*, 0) DEFAULT 0 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXTOTDEMCOMPETENCIA ON DWTOTDEMCOMPETENCIA (ANYO ASC, FIDCOMPETENCIA ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE DWTOTDEMCOMPETENCIA
ADD CONSTRAINT DWTOTDEMCOMPETENCIA_PK PRIMARY KEY 
(
  ANYO 
, FIDCOMPETENCIA 
)
USING INDEX INDEXTOTDEMCOMPETENCIA
ENABLE;



/***********************************************************/
/*         27- Creaci de la taula DWTOP5COMPETENCIA       */
/***********************************************************/
CREATE TABLE DWTOP5COMPETENCIA 
(
  ANYO NUMBER(*, 0) NOT NULL 
, DESCRIPCIO NVARCHAR2(50) NOT NULL 
, TOTAL NUMBER(*, 0) DEFAULT 0 
-- Definici de clau principal
, CONSTRAINT DWTOP5COMPETENCIA_PK PRIMARY KEY 
  (
    ANYO 
  , DESCRIPCIO 
  )
  USING INDEX 
  (
      -- Creaci de l'ndex per a la clau principal
      CREATE UNIQUE INDEX DWTOP5COMPETENCIA_PK ON DWTOP5COMPETENCIA (ANYO ASC, DESCRIPCIO ASC) 
      LOGGING 
      TABLESPACE RECRUITCAT_DATA 
      PCTFREE 10 
      INITRANS 2 
      STORAGE 
      ( 
        INITIAL 65536 
        NEXT 1048576 
        MINEXTENTS 1 
        MAXEXTENTS UNLIMITED 
        BUFFER_POOL DEFAULT 
      ) 
      NOPARALLEL 
  )
  ENABLE 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;



/***********************************************************/
/*         28- Creaci de la taula DWCLIENTMESACC          */
/***********************************************************/
CREATE TABLE DWCLIENTMESACC 
(
  IDCLIENTMESACC NUMBER(*, 0) DEFAULT 1 NOT NULL 
, NOM NVARCHAR2(50) 
, TOTALCANDACCEPTATS NUMBER(*, 0) DEFAULT 0 
-- Definici de clau principal
, CONSTRAINT DWCLIENTMESACC_PK PRIMARY KEY 
  (
    IDCLIENTMESACC 
  )
  USING INDEX 
  (
      -- Creaci de l'ndex per a la clau principal
      CREATE UNIQUE INDEX DWCLIENTMESACC_PK ON DWCLIENTMESACC (IDCLIENTMESACC ASC) 
      LOGGING 
      TABLESPACE RECRUITCAT_DATA 
      PCTFREE 10 
      INITRANS 2 
      STORAGE 
      ( 
        INITIAL 65536 
        NEXT 1048576 
        MINEXTENTS 1 
        MAXEXTENTS UNLIMITED 
        BUFFER_POOL DEFAULT 
      ) 
      NOPARALLEL 
  )
  ENABLE 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

/***********************************************************/
/*         29- Creaci de la taula DWDENEGCLIENTS          */
/***********************************************************/
CREATE TABLE DWDENEGCLIENTS 
(
  ANYO NUMBER(*, 0) NOT NULL 
, FIDCLIENT NUMBER(*, 0) NOT NULL 
, NOM NVARCHAR2(50) 
, TOTALPROPDENEGADES NUMBER(*, 0) DEFAULT 0 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXDNEGCLIENTS ON DWDENEGCLIENTS (ANYO ASC, FIDCLIENT ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE DWDENEGCLIENTS
ADD CONSTRAINT DWDENEGCLIENTS_PK PRIMARY KEY 
(
  ANYO 
, FIDCLIENT 
)
USING INDEX INDEXDNEGCLIENTS
ENABLE;


/***********************************************************/
/*         30- Creaci de la taula DWTOPDENEGCLIENT        */
/***********************************************************/
CREATE TABLE DWTOPDENEGCLIENT 
(
  ANYO NUMBER(*, 0) NOT NULL 
, NOM NVARCHAR2(50) NOT NULL 
, TOTAL NUMBER(*, 0) DEFAULT 0
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Creaci de l'ndex per a la clau principal
CREATE UNIQUE INDEX INDEXTOPDENEGCLIENT ON DWTOPDENEGCLIENT (ANYO ASC, NOM ASC) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 2 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;

-- Definici de clau principal
ALTER TABLE DWTOPDENEGCLIENT
ADD CONSTRAINT DWTOPDENEGCLIENT_PK PRIMARY KEY 
(
  ANYO 
, NOM 
)
USING INDEX INDEXTOPDENEGCLIENT
ENABLE;



/***********************************************************/
/*         31- Creaci de la taula DWVISITCOMERCIAL        */
/***********************************************************/
CREATE TABLE DWVISITCOMERCIAL 
(
  IDVISITCOM VARCHAR2(20 BYTE) DEFAULT 1 NOT NULL 
, NOM VARCHAR2(50 BYTE) NOT NULL 
, TOTAL NUMBER(*, 0) DEFAULT 0 
-- Definici de clau principal
, CONSTRAINT DWVISITCOMERCIAL_PK PRIMARY KEY 
  (
    IDVISITCOM 
  )
  USING INDEX 
  (
      -- Creaci de l'ndex per a la clau principal
      CREATE UNIQUE INDEX DWVISITCOMERCIAL_PK ON DWVISITCOMERCIAL (IDVISITCOM ASC) 
      LOGGING 
      TABLESPACE RECRUITCAT_DATA 
      PCTFREE 10 
      INITRANS 2 
      STORAGE 
      ( 
        INITIAL 65536 
        NEXT 1048576 
        MINEXTENTS 1 
        MAXEXTENTS UNLIMITED 
        BUFFER_POOL DEFAULT 
      ) 
      NOPARALLEL 
  )
  ENABLE 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;


/***********************************************************/
/*         32- Creaci de la taula DWCAPCANDCLIENTS        */
/***********************************************************/
CREATE TABLE DWCAPCANDCLIENTS 
(
  IDCAPCANDCLIENTS NUMBER(*, 0) DEFAULT 1 NOT NULL 
, TIPUS NVARCHAR2(50) NOT NULL 
, NUMCAND NUMBER(*, 0) DEFAULT 0
-- Definici de clau principal
, CONSTRAINT DWCAPCANDCLIENTS_PK PRIMARY KEY 
  (
    IDCAPCANDCLIENTS 
  )
  USING INDEX 
  (
      -- Creaci de l'ndex per a la clau principal
      CREATE UNIQUE INDEX DWCAPCANDCLIENTS_PK ON DWCAPCANDCLIENTS (IDCAPCANDCLIENTS ASC) 
      LOGGING 
      TABLESPACE RECRUITCAT_DATA 
      PCTFREE 10 
      INITRANS 2 
      STORAGE 
      ( 
        INITIAL 65536 
        NEXT 1048576 
        MINEXTENTS 1 
        MAXEXTENTS UNLIMITED 
        BUFFER_POOL DEFAULT 
      ) 
      NOPARALLEL 
  )
  ENABLE 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;


/***********************************************************/
/*         33- Creaci de la taula DWMENYSENTSEU           */
/***********************************************************/
CREATE TABLE DWMENYSENTSEU 
(
  IDMENYSENTSEU NUMBER(*, 0) DEFAULT 1 NOT NULL 
, FIDSEU NUMBER(*, 0) NOT NULL 
, NUMENT NUMBER(*, 0) DEFAULT 0 
-- Definici de clau principal
, CONSTRAINT DWMENYSENTSEU_PK PRIMARY KEY 
  (
    IDMENYSENTSEU 
  )
  USING INDEX 
  (
      -- Creaci de l'ndex per a la clau principal
      CREATE UNIQUE INDEX DWMENYSENTSEU_PK ON DWMENYSENTSEU (IDMENYSENTSEU ASC) 
      LOGGING 
      TABLESPACE RECRUITCAT_DATA 
      PCTFREE 10 
      INITRANS 2 
      STORAGE 
      ( 
        INITIAL 65536 
        NEXT 1048576 
        MINEXTENTS 1 
        MAXEXTENTS UNLIMITED 
        BUFFER_POOL DEFAULT 
      ) 
      NOPARALLEL 
  )
  ENABLE 
) 
LOGGING 
TABLESPACE RECRUITCAT_DATA 
PCTFREE 10 
INITRANS 1 
STORAGE 
( 
  INITIAL 65536 
  NEXT 1048576 
  MINEXTENTS 1 
  MAXEXTENTS UNLIMITED 
  BUFFER_POOL DEFAULT 
) 
NOPARALLEL;


/***********************************************************/
/*            Creaci de seqncies                        */
/***********************************************************/
-- Creaci de seqncia per a la clau primria autoincremental de la taula Responsable
CREATE SEQUENCE SEQRESPONSABLE
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula NivellEstudis
CREATE SEQUENCE SEQESTUDIS 
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula CompetenciaProfessional
CREATE SEQUENCE SEQCOMPETENCIA
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula Seu
CREATE SEQUENCE SEQSEU 
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula Comercial
CREATE SEQUENCE SEQCOMERCIAL 
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula Client
CREATE SEQUENCE SEQCLIENT 
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula ProcesCaptacio
CREATE SEQUENCE SEQPROCESCAP 
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula Candidat
CREATE SEQUENCE SEQCANDIDAT 
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula EntrevistaInterna
CREATE SEQUENCE SEQENTREVISTAI
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;
  
-- Creaci de seqncia per a la clau primria autoincremental de la taula ProcesSeleccio
CREATE SEQUENCE SEQPROCESSEL
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula EntrevistaExterna
CREATE SEQUENCE SEQENTREVISTAE
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula VisitaComercial
CREATE SEQUENCE SEQVISITA
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula PropostaComercial
CREATE SEQUENCE SEQPROPOSTA
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;

-- Creaci de seqncia per a la clau primria autoincremental de la taula Log
CREATE SEQUENCE SEQLOG
  START WITH 1
  INCREMENT BY 1 
  MAXVALUE 9999999999999999999999999999
  MINVALUE 1
  NOCYCLE
  NOCACHE
  NOORDER;


/***********************************************************/
/*            Creaci de disparadors de seqncia          */
/***********************************************************/

-- Disparador de seqncia per a la taula Responsable
create or replace trigger TRGRESPONSABLE  
   before insert on "ECOLLADOF"."RESPONSABLE" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDRESPONSABLE" is null then 
         select SEQRESPONSABLE.nextval into :NEW."IDRESPONSABLE" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula NivellEstudis
create or replace trigger TRGESTUDIS  
   before insert on "ECOLLADOF"."NIVELLESTUDIS" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDESTUDIS" is null then 
         select SEQESTUDIS.nextval into :NEW."IDESTUDIS" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula CompetenciaProfessional
create or replace trigger TRGCOMPETENCIA  
   before insert on "ECOLLADOF"."COMPETENCIAPROFESSIONAL" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDCOMPETENCIA" is null then 
         select SEQCOMPETENCIA.nextval into :NEW."IDCOMPETENCIA" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula Seu
create or replace trigger TRGSEU  
   before insert on "ECOLLADOF"."SEU" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDSEU" is null then 
         select SEQSEU.nextval into :NEW."IDSEU" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula Comercial
create or replace trigger TRGCOMERCIAL  
   before insert on "ECOLLADOF"."COMERCIAL" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDCOMERCIAL" is null then 
         select SEQCOMERCIAL.nextval into :NEW."IDCOMERCIAL" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula Client
create or replace trigger TRGCLIENT  
   before insert on "ECOLLADOF"."CLIENT" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDCLIENT" is null then 
         select SEQCLIENT.nextval into :NEW."IDCLIENT" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula ProcesCaptacio
create or replace trigger TRGPROCESCAP  
   before insert on "ECOLLADOF"."PROCESCAPTACIO" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDPROCESCAP" is null then 
         select SEQPROCESCAP.nextval into :NEW."IDPROCESCAP" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula Candidat
create or replace trigger TRGCANDIDAT  
   before insert on "ECOLLADOF"."CANDIDAT" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDCANDIDAT" is null then 
         select SEQCANDIDAT.nextval into :NEW."IDCANDIDAT" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula EntrevistaInterna
create or replace trigger TRGENTREVISTAI  
   before insert on "ECOLLADOF"."ENTREVISTAINTERNA" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDENTREVISTAI" is null then 
         select SEQENTREVISTAI.nextval into :NEW."IDENTREVISTAI" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula ProcesSeleccio
create or replace trigger TRGPROCESSEL  
   before insert on "ECOLLADOF"."PROCESSELECCIO" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDPROCESSEL" is null then 
         select SEQPROCESSEL.nextval into :NEW."IDPROCESSEL" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula EntrevistaExterna
create or replace trigger TRGENTREVISTAE  
   before insert on "ECOLLADOF"."ENTREVISTAEXTERNA" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDENTREVISTAE" is null then 
         select SEQENTREVISTAE.nextval into :NEW."IDENTREVISTAE" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula VisitaComercial
create or replace trigger TRGVISITA  
   before insert on "ECOLLADOF"."VISITACOMERCIAL" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDVISITA" is null then 
         select SEQVISITA.nextval into :NEW."IDVISITA" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula Comercial
create or replace trigger TRGCOMERCIAL
   before insert on "ECOLLADOF"."COMERCIAL"
   for each row
begin
   if inserting then
      if :NEW."IDCOMERCIAL" is null then
         select SEQCOMERCIAL.nextval into :NEW."IDCOMERCIAL" from dual;
      end if;
   end if;
end;
/

-- Disparador de seqncia per a la taula PropostaComercial
create or replace trigger TRGPROPOSTA  
   before insert on "ECOLLADOF"."PROPOSTACOMERCIAL" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDPROPOSTA" is null then 
         select SEQPROPOSTA.nextval into :NEW."IDPROPOSTA" from dual; 
      end if; 
   end if; 
end;
/

-- Disparador de seqncia per a la taula Log
create or replace trigger TRGLOG  
   before insert on "ECOLLADOF"."LOG" 
   for each row 
begin  
   if inserting then 
      if :NEW."IDLOG" is null then 
         select SEQLOG.nextval into :NEW."IDLOG" from dual; 
      end if; 
   end if; 
end;
/


commit;
