/* IMPORTANT: s necessari estar connectat amb l'usuari ECOLLADOF amb password 12345678 abans d'executar aquest script                                           */
/* En aquest script es troben els disparadors i procediments que fan possible que les taules */
/* del magatzem de dades tinguin sempre les dades actualitzades                              */

/***********************************************************/
/*   TRIGGERS I PROCEDIMENTS PER A LA GESTI DEL DW        */
/***********************************************************/

-------------------------------------------------------------
--Nom        :   PROC_DWMILLORPROCCCAP
--Cas d's   :   CU20 - Procs de captaci amb ms candidats seleccionats en processos
--Descripci :   Actualitza taula DWMILLORPROCCCAP
-------------------------------------------------------------
CREATE OR REPLACE PROCEDURE PROC_DWMILLORPROCCAP 
IS
PTIPUS PROCESCAPTACIO.TIPUS%TYPE;
PNUMCAND Integer;
num_reg Integer;
BEGIN
  -- ACTUALITZEM LA TAULA DWMILLORPROCCAP DEL CU20
  -- cerquem el procs de captaci que ms candidats han participat en processso de seleci
  SELECT TIPUS, NUMACCPROCSEL INTO PTIPUS, PNUMCAND FROM (SELECT TIPUS, NUMACCPROCSEL FROM PROCESCAPTACIO ORDER BY NUMACCPROCSEL DESC) WHERE ROWNUM=1;
  -- comprovem si esisteix el registre nic de la taula, per inserir o b actualitzar-lo
  SELECT count (IDMILLORPROCCAP) INTO num_reg FROM DWMILLORPROCCAP;
    IF num_reg=0 THEN
      INSERT INTO DWMILLORPROCCAP(IDMILLORPROCCAP, TIPUS, TOTALPROCESSEL) VALUES (1, PTIPUS, PNUMCAND);
    ELSE
      UPDATE DWMILLORPROCCAP SET TIPUS=PTIPUS, TOTALPROCESSEL=PNUMCAND WHERE IDMILLORPROCCAP=1;
    END IF;
END PROC_DWMILLORPROCCAP;
/

-------------------------------------------------------------
--Nom        :   PROC_DWCAPCANDCLIENTS
--Cas d's   :   CU27 - Procs de captaci que ms candidats ha proporcionat als clients
--Descripci :   Actualitza taula DWCAPCANDCLIENTS
-------------------------------------------------------------
CREATE OR REPLACE PROCEDURE PROC_DWCAPCANDCLIENTS 
IS
PTIPUS PROCESCAPTACIO.TIPUS%TYPE;
PNUMCAND Integer;
num_reg Integer;
BEGIN
  -- ACTUALITZEM LA TAULA DWMCAPCANDCLIENTS DEL CU27
  -- cerquem el procs de captaci que ms candidats ens ha acceptat el client
  SELECT TIPUS, NUMSELCLIENTANYACTUAL INTO PTIPUS, PNUMCAND FROM (SELECT TIPUS, NUMSELCLIENTANYACTUAL FROM PROCESCAPTACIO ORDER BY NUMSELCLIENTANYACTUAL DESC) WHERE ROWNUM=1;
  -- comprovem si esisteix el registre nic de la taula per inserir o b actualitzar-lo
  SELECT count (IDCAPCANDCLIENTS) INTO num_reg FROM DWCAPCANDCLIENTS;
    IF num_reg=0 THEN
      INSERT INTO DWCAPCANDCLIENTS(IDCAPCANDCLIENTS, TIPUS, NUMCAND) VALUES (1, PTIPUS, PNUMCAND);
    ELSE
      UPDATE DWCAPCANDCLIENTS SET TIPUS=PTIPUS, NUMCAND=PNUMCAND WHERE IDCAPCANDCLIENTS=1;
    END IF;
END PROC_DWCAPCANDCLIENTS;
/

-------------------------------------------------------------
--Nom        :   PROC_DWVISITCOMERCIAL
--Cas d's   :   CU26 - Comercial que ha realitzat ms visites en l'any actual
--Descripci :   Actualitza taula DWVISITCOMERCIAL
-------------------------------------------------------------
CREATE OR REPLACE PROCEDURE PROC_DWVISITCOMERCIAL 
IS
PNOM COMERCIAL.NOM%TYPE;
PNUMVIS Integer;
num_reg Integer;
BEGIN
  -- ACTUALITZEM LA TAULA DWVISITCOMERCIAL DEL CU26
  -- cerquem el comercial que ha fet ms visites
  SELECT NOM, VISITESANYACTUAL INTO PNOM, PNUMVIS 
    FROM (SELECT NOM, VISITESANYACTUAL FROM COMERCIAL WHERE DATABAIXA IS NULL ORDER BY VISITESANYACTUAL DESC, NOM) WHERE ROWNUM=1;
  -- comprovem si esisteix el registre nic de la taula per inserir o b actualitzar-lo
  SELECT count (IDVISITCOM) INTO num_reg FROM DWVISITCOMERCIAL;
    IF num_reg=0 THEN
      INSERT INTO DWVISITCOMERCIAL(IDVISITCOM, NOM, TOTAL) VALUES (1, PNOM, PNUMVIS);
    ELSE
      UPDATE DWVISITCOMERCIAL SET NOM=PNOM, TOTAL=PNUMVIS WHERE IDVISITCOM=1;
    END IF;
END PROC_DWVISITCOMERCIAL;
/
-------------------------------------------------------------
--Nom        :   PROC_DWCOMMILLORRATIO
--Cas d's   :   CU19 - Comercial amb millor rtio
--Descripci :   Actualitza taula DWCOMMILLORRATIO
-------------------------------------------------------------
create or replace PROCEDURE PROC_DWCOMMILLORRATIO 
IS
PIDCOMERCIAL Integer;
PNOM  COMERCIAL.NOM%TYPE;
PRATIO Float;
num_reg Integer;
BEGIN
  -- ACTUALITZEM LA TAULA DWCOMMILLORRATIO  DEL CU19
  -- cerquem el comercial que t millor rtio
  SELECT IDCOMERCIAL, NOM, RATIO INTO PIDCOMERCIAL, PNOM, PRATIO FROM (SELECT IDCOMERCIAL, NOM, RATIO 
    FROM COMERCIAL WHERE DATABAIXA IS NULL ORDER BY RATIO DESC, NOM) WHERE ROWNUM=1;
  -- comprovem si esisteix el registre nic de la taula per inserir o actualitzar-lo
  SELECT count (IDCOMMILLORRATIO) INTO num_reg FROM DWCOMMILLORRATIO;
    IF num_reg=0 THEN
      INSERT INTO DWCOMMILLORRATIO(IDCOMMILLORRATIO, NOMCOMERCIAL, RATIO) VALUES (1, PNOM, PRATIO);
    ELSE
      UPDATE DWCOMMILLORRATIO SET NOMCOMERCIAL=PNOM, RATIO=PRATIO WHERE IDCOMMILLORRATIO=1;
    END IF;
END PROC_DWCOMMILLORRATIO;
/

-------------------------------------------------------------
--Nom        :   PROC_DWTOP10ESTUDIS
--Cas d's   :   CU21 - Top 10 dels nivell d'estudis d'un any
--Descripci :   Actualitza taula DWTOP10ESTUDIS
-------------------------------------------------------------
create or replace PROCEDURE PROC_DWTOP10ESTUDIS
(
  PANYO IN DWTOP10ESTUDIS.ANYO%TYPE
)
IS
num_reg Integer;
ppanyo  Integer;
pptipus DWTOTDEMESTUDIS.TIPUS%TYPE;
CURSOR cur_estudis IS
     SELECT * FROM
            (SELECT ANYO, TIPUS, TOTALDEMANATSPROCES FROM DWTOTDEMESTUDIS WHERE ANYO=PANYO AND TOTALDEMANATSPROCES>0
             ORDER BY TOTALDEMANATSPROCES DESC, TIPUS)
     WHERE ROWNUM<=10;
BEGIN
  -- ACTUALITZEM LA TAULA DWTOP10ESTUDIS DEL CU21
  -- eliminem els registreS de l'any
  DELETE FROM DWTOP10ESTUDIS WHERE ANYO=PANYO;
  -- Inserim els TOP 10 registres de l'any
  FOR i in cur_estudis LOOP
    INSERT INTO DWTOP10ESTUDIS(ANYO,TIPUS, TOTAL)  VALUES (i.ANYO, i.TIPUS, i.TOTALDEMANATSPROCES);
  END LOOP;
END PROC_DWTOP10ESTUDIS;
/

-------------------------------------------------------------
--Nom        :   PROC_DWCLIENTMESACC
--Cas d's   :   CU23 - Client que ms candidats ens ha acceptat
--Descripci :   Actualitza taula DWCLIENTMESACC
-------------------------------------------------------------
create or replace PROCEDURE PROC_DWCLIENTMESACC
IS
PIDCLIENT Integer;
PNOM	CLIENT.NOM%Type;
PNUMCAND Integer;
num_reg Integer;
BEGIN
  -- ACTUALITZEM LA TAULA DWCLIENTMESACC DEL CU23
  -- cerquem el client que ms candidats ens ha aceptat
  SELECT IDCLIENT, NOM, NUMCANDACCEPTATS INTO PIDCLIENT, PNOM, PNUMCAND 
    FROM (SELECT IDCLIENT, NOM, NUMCANDACCEPTATS FROM CLIENT ORDER BY NUMCANDACCEPTATS DESC, NOM) WHERE ROWNUM=1;
  -- comprovem si existeix el registre nic de la taula per inserir o actualitzar-lo
  SELECT count (IDCLIENTMESACC) INTO num_reg FROM DWCLIENTMESACC;
    IF num_reg=0 THEN
      INSERT INTO DWCLIENTMESACC (IDCLIENTMESACC, NOM, TOTALCANDACCEPTATS) VALUES (1, PNOM, PNUMCAND);
    ELSE
      UPDATE DWCLIENTMESACC SET NOM=PNOM, TOTALCANDACCEPTATS=PNUMCAND WHERE IDCLIENTMESACC=1;
    END IF;
END PROC_DWCLIENTMESACC;
/
-------------------------------------------------------------
--Nom        :   PROC_DWTOP5COMPETENCIA
--Cas d's   :   CU22 - Top 5 competencies en processos selecci
--Descripci :   Actualitza taula DWTOP5COMPETENCIA
-------------------------------------------------------------
create or replace PROCEDURE PROC_DWTOP5COMPETENCIA (
  PANYO IN DWTOP5COMPETENCIA.ANYO%TYPE
)
IS
num_reg Integer;
ppanyo  Integer;
ppdescripcio DWTOTDEMCOMPETENCIA.DESCRIPCIO%TYPE;
CURSOR cur_comp IS
     SELECT ANYO, DESCRIPCIO, TOTALDEMANATSPROCES FROM(SELECT ANYO, DESCRIPCIO, TOTALDEMANATSPROCES FROM DWTOTDEMCOMPETENCIA 
       WHERE ANYO=PANYO AND TOTALDEMANATSPROCES>0 ORDER BY TOTALDEMANATSPROCES DESC, DESCRIPCIO)WHERE ROWNUM<=5;
BEGIN
  -- ACTUALITZEM LA TAULA DWTOP5COMPETENCIA DEL CU22
  -- eliminem els registres de l'any
  DELETE FROM DWTOP5COMPETENCIA WHERE ANYO=PANYO;
  -- Inserim els TOP 5 registres de l'any
  FOR i in cur_comp LOOP
    --dbms_output.put_line(i.ANYO || ' ' || i.descripcio || ' ' || i.TOTALDEMANATSPROCES);
    INSERT INTO DWTOP5COMPETENCIA(ANYO,DESCRIPCIO, TOTAL)  VALUES (i.ANYO, i.DESCRIPCIO, i.TOTALDEMANATSPROCES);
  END LOOP;
END PROC_DWTOP5COMPETENCIA;
/

-------------------------------------------------------------
--Nom        :   PROC_DWTOPDENEGCLIENT
--Cas d's   :   CU24 - Client amb ms propostes denegades
--Descripci :   Actualitza taula DWTOPDENEGCLIENT
-------------------------------------------------------------
CREATE OR REPLACE PROCEDURE PROC_DWTOPDENEGCLIENT 
(
  PANYO IN DWTOPDENEGCLIENT.ANYO%TYPE
)
IS
num_reg Integer;
PNOM  DWTOPDENEGCLIENT.NOM%TYPE;
PTOTAL  DWTOPDENEGCLIENT.TOTAL%TYPE;
PFIDCLIENT  DWDENEGCLIENTS.FIDCLIENT%TYPE;
CURSOR cur_cli IS
     SELECT * FROM 
            (SELECT ANYO, NOM, TOTALPROPDENEGADES FROM DWDENEGCLIENTS WHERE ANYO=PANYO AND TOTALPROPDENEGADES>0
             ORDER BY TOTALPROPDENEGADES DESC, NOM)
     WHERE ROWNUM<=1;
BEGIN
  -- ACTUALITZEM LA TAULA DWTOPDENEGCLIENT DEL CU24
  -- eliminem els registreS de l'any
  DELETE FROM DWTOPDENEGCLIENT WHERE ANYO=PANYO;
  -- cerquem el client que ms propostes ens ha denegat
  -- Inserim el TOP de l'any
  FOR i in cur_cli LOOP
    INSERT INTO DWTOPDENEGCLIENT(ANYO, NOM, TOTAL)  VALUES (i.ANYO, i.NOM, i.TOTALPROPDENEGADES);
  END LOOP;
END PROC_DWTOPDENEGCLIENT;
/

-------------------------------------------------------------
--Nom        :   PROC_DWMENYSENTSEU
--Cas d's   :   CU28 - Seu amb menys entrevistes internes
--Descripci :   Actualitza taula DWMENYSENTSEU
-------------------------------------------------------------
create or replace PROCEDURE PROC_DWMENYSENTSEU
IS
PIDSEU Integer;
PNUMENT Integer;
num_reg Integer;
BEGIN
  -- ACTUALITZEM LA TAULA DWMENYSENTSEU DEL CU28
  -- cerquem la Seu que ha fet menys entrevistes (descartant aquelles que no n'hagin fet cap per considerar que temporalment no estan actives)
  SELECT IDSEU, NUMENTANYACTUAL INTO PIDSEU, PNUMENT FROM (SELECT IDSEU, NUMENTANYACTUAL FROM SEU WHERE DATABAIXA IS NULL AND NUMENTANYACTUAL>0 ORDER BY NUMENTANYACTUAL, IDSEU) WHERE ROWNUM=1;
  -- comprovem si esisteix el registre nic de la taula per inserir o actualitzar-lo
  SELECT count (IDMENYSENTSEU) INTO num_reg FROM DWMENYSENTSEU;
    IF num_reg=0 THEN
      INSERT INTO DWMENYSENTSEU(IDMENYSENTSEU, FIDSEU, NUMENT) VALUES (1, PIDSEU, PNUMENT);
    ELSE
      UPDATE DWMENYSENTSEU SET FIDSEU=PIDSEU, NUMENT=PNUMENT WHERE IDMENYSENTSEU=1;
    END IF;
END PROC_DWMENYSENTSEU;
/

-------------------------------------------------------------
--Nom        :   DW_TRGENTREVISTAE
--Cas d's   :   CU25 - Candidats no seleccionats per cap client
--               CU27 - Procs de captaci que ms candidats ha proporcionat als clients
--Descripci :   Cada cop que s'actualtiza la taula ENTREVISTAEXTERNA
-- s'actualitzen comptadors de les taules CANDIDAT i PROCESCAPTACIO 
-- i la taula del magatzem de dades DWCAPCANDCLIENTS

-------------------------------------------------------------
create or replace TRIGGER DW_TRGENTREVISTAE 
AFTER INSERT OR UPDATE ON ENTREVISTAEXTERNA 
REFERENCING OLD AS OLD NEW AS NEW 
FOR EACH ROW 
DECLARE
PDATA   ENTREVISTAEXTERNA.DATA%TYPE;
PANYO    Integer;
PANYOACTUAL Integer;
PFIDCANDIDAT ENTREVISTAEXTERNA.FIDCANDIDAT%TYPE;
PFIDPROCESCAP  CANDIDAT.FIDPROCESCAP%TYPE;
PRESUL ENTREVISTAEXTERNA.RESULTAT%TYPE;
RESULOLD ENTREVISTAEXTERNA.RESULTAT%TYPE;
RESULNEW ENTREVISTAEXTERNA.RESULTAT%TYPE;
num_sel_client  Integer;

BEGIN
  PDATA:=:new.DATA;
  RESULOLD:=:old.RESULTAT;
  RESULNEW:=:new.RESULTAT;
  PRESUL:=:new.RESULTAT;
  PFIDCANDIDAT:=:new.FIDCANDIDAT;
  -- Extraiem l'any de la data del sistema
  SELECT EXTRACT(Year FROM SYSDATE) INTO PANYOACTUAL FROM DUAL;
  -- Extraiem l'any de la data de l'entrevista
  SELECT EXTRACT(Year FROM PDATA) INTO PANYO FROM DUAL;
  IF INSERTING THEN
    -- CU25 ACTUALITZEM LA TAULA CANDIDAT 
    -- Mirem si el candidat ha estat seleccionat
    IF RESULNEW='P' THEN
      UPDATE CANDIDAT SET SELCLIENT='S' WHERE IDCANDIDAT=PFIDCANDIDAT;
      -- CU27 ACTUALITZEM LA TAULA PROCESCAPTACIO
      IF PANYO=PANYOACTUAL THEN
        --Mirem quin s el procs de captaci del candidat
        SELECT FIDPROCESCAP INTO PFIDPROCESCAP FROM CANDIDAT WHERE IDCANDIDAT=PFIDCANDIDAT;
        --Mirem el comptador de seleccionats fins ara
        SELECT NUMSELCLIENTANYACTUAL INTO num_sel_client FROM PROCESCAPTACIO WHERE IDPROCESCAP=PFIDPROCESCAP;
        --Incrementem el comptador
        UPDATE PROCESCAPTACIO SET NUMSELCLIENTANYACTUAL=num_sel_client +1 WHERE IDPROCESCAP=PFIDPROCESCAP;
        PROC_DWCAPCANDCLIENTS;
      END IF;
    END IF;
  END IF;
  IF UPDATING AND :new.DATABAIXA IS NULL THEN
     -- CU25 ACTUALITZEM LA TAULA CANDIDAT 
    -- Mirem si el candidat ha estat seleccionat
    IF RESULNEW='P' AND RESULOLD!='P' THEN
      UPDATE CANDIDAT SET SELCLIENT='S' WHERE IDCANDIDAT=PFIDCANDIDAT;
      -- CU27 ACTUALITZEM LA TAULA PROCESCAPTACIO
      IF PANYO=PANYOACTUAL THEN
        --Mirem quin s el procs de captaci del candidat
        SELECT FIDPROCESCAP INTO PFIDPROCESCAP FROM CANDIDAT WHERE IDCANDIDAT=PFIDCANDIDAT;
        --Mirem el comptador de seleccionats fins ara
        SELECT NUMSELCLIENTANYACTUAL INTO num_sel_client FROM PROCESCAPTACIO WHERE IDPROCESCAP=PFIDPROCESCAP;
        --Incrementem el comptador
        UPDATE PROCESCAPTACIO SET NUMSELCLIENTANYACTUAL=num_sel_client +1 WHERE IDPROCESCAP=PFIDPROCESCAP;
        PROC_DWCAPCANDCLIENTS;
      END IF;
    END IF;  
    IF RESULOLD='P' AND RESULNEW!='P' THEN
      UPDATE CANDIDAT SET SELCLIENT='N' WHERE IDCANDIDAT=PFIDCANDIDAT;
      -- CU27 ACTUALITZEM LA TAULA PROCESCAPTACIO
      IF PANYO=PANYOACTUAL THEN
        --Mirem quin s el procs de captaci del candidat
        SELECT FIDPROCESCAP INTO PFIDPROCESCAP FROM CANDIDAT WHERE IDCANDIDAT=PFIDCANDIDAT;
        --Mirem el comptador de seleccionats fins ara
        SELECT NUMSELCLIENTANYACTUAL INTO num_sel_client FROM PROCESCAPTACIO WHERE IDPROCESCAP=PFIDPROCESCAP;
        --Decrementem el comptador
        UPDATE PROCESCAPTACIO SET NUMSELCLIENTANYACTUAL=num_sel_client -1 WHERE IDPROCESCAP=PFIDPROCESCAP;
        PROC_DWCAPCANDCLIENTS;
      END IF; 
    END IF;
  END IF;
END DW_TRGENTREVISTAE;
/

-------------------------------------------------------------
--Nom        :   DW_TRGCANDPROC
--Cas d's   :   CU17 - Candidats no seleccionats en cap procs de selecci
--Descripci :   Cada cop que s'actualtiza la taula CANDIDATPROCESSEL
-- s'actualtiza la taula Candidat que ens servir per calcular el CU17
-------------------------------------------------------------
create or replace TRIGGER DW_TRGCANDPROC 
AFTER INSERT OR UPDATE ON CANDIDATPROCESSEL 
REFERENCING OLD AS old NEW AS new
FOR EACH ROW
DECLARE
PFIDPROCESSEL CANDIDATPROCESSEL.FIDPROCESSEL%TYPE;
PFIDCANDIDAT CANDIDATPROCESSEL.FIDCANDIDAT%TYPE;
num_reg Integer;
num_proc  Integer;

BEGIN
  PFIDPROCESSEL:=:new.FIDPROCESSEL;
  PFIDCANDIDAT:=:new.FIDCANDIDAT;
  IF INSERTING THEN
    -- CU17 ACTUALITZEM LA TAULA CANDIDAT 
    -- Incrementem el comptador de processos de selecci del candidat
    SELECT NUMPROCESSEL INTO num_proc FROM CANDIDAT WHERE IDCANDIDAT=PFIDCANDIDAT;
    UPDATE CANDIDAT SET NUMPROCESSEL=num_proc+1 WHERE IDCANDIDAT=PFIDCANDIDAT;
  END IF;
  IF UPDATING THEN
    IF :new.DATABAIXA IS NOT NULL THEN
      -- CU17 ACTUALITZEM LA TAULA CANDIDAT 
      -- Decrementem el comptador de processos de selecci del candidat
      SELECT NUMPROCESSEL INTO num_proc FROM CANDIDAT WHERE IDCANDIDAT=PFIDCANDIDAT;
      UPDATE CANDIDAT SET NUMPROCESSEL=num_proc-1 WHERE IDCANDIDAT=PFIDCANDIDAT;
    END IF;
  END IF;
END DW_TRGCANDPROC;
/
-------------------------------------------------------------
--Nom        :   DW_TRGVISITCOMERCIAL 
--Cas d's   :   CU26 - Comercial que ha realitzat ms visites en l'any actual
--Descripci :   Cada cop que s'actualitza la taula VISITACOMERCAL 
-- s'actualitzen camp de la taula COMERCIAL i taula DWVISITCOMERCIAL
-------------------------------------------------------------
create or replace TRIGGER DW_TRGVISITCOMERCIAL 
AFTER INSERT OR UPDATE ON VISITACOMERCIAL 
REFERENCING OLD AS OLD NEW AS NEW 
FOR EACH ROW 
DECLARE
PDATA   VISITACOMERCIAL.DATAVISITA%TYPE;
PANYO    Integer;
PANYACTUAL Integer;
PFIDCOMERCIAL VISITACOMERCIAL.FIDCOMERCIAL%TYPE;
num_reg integer;
num_vis integer;

BEGIN
  PDATA:=:new.DATAVISITA;
  PFIDCOMERCIAL:=:new.FIDCOMERCIAL;
  -- Extraiem l'any de la data de la visita
  SELECT EXTRACT(Year FROM PDATA) INTO PANYO FROM DUAL;
  SELECT EXTRACT(Year FROM SYSDATE) INTO PANYACTUAL FROM DUAL;
  IF INSERTING THEN
    -- CU26 - ACTUALITXEM LA TAULA COMERCIAL I DWVISITCOMERCIAL (si estem en l'any en curs)
    IF PANYO=PANYACTUAL THEN
      SELECT VISITESANYACTUAL INTO num_vis FROM COMERCIAL WHERE IDCOMERCIAL=PFIDCOMERCIAL;
      UPDATE COMERCIAL SET VISITESANYACTUAL=num_vis+1 WHERE IDCOMERCIAL=PFIDCOMERCIAL;
      PROC_DWVISITCOMERCIAL;
    END IF;
  END IF;
  IF UPDATING AND :new.DATABAIXA IS NOT NULL THEN
       -- CU26 - ACTUALITXEM LA TAULA COMERCIAL I DWVISITCOMERCIAL (si estem en l'any en curs)
      IF PANYO=PANYACTUAL THEN
        SELECT VISITESANYACTUAL INTO num_vis FROM COMERCIAL WHERE IDCOMERCIAL=PFIDCOMERCIAL;
        UPDATE COMERCIAL SET VISITESANYACTUAL=num_vis-1 WHERE IDCOMERCIAL=PFIDCOMERCIAL;
        PROC_DWVISITCOMERCIAL;
      END IF;
  END IF;
END DW_TRGVISITCOMERCIAL ;
/


-------------------------------------------------------------
--Nom        :   DW_TRGENTREVISTAI
--Cas d's   :   CU15 - Nmero d'entrevistes internes per any
--               CU28 - Seu amb menys entrevistes internes
--Descripci :   Cada cop que es fa una actualitzaci a la taula ENTREVISTAINTERNA
-- s'actualitzen les taules DWNUMENTI, DWMENYSENTSEU i SEU
-------------------------------------------------------------
create or replace TRIGGER DW_TRGENTREVISTAI
AFTER INSERT OR UPDATE ON ENTREVISTAINTERNA
REFERENCING OLD AS old NEW AS new
FOR EACH ROW
DECLARE
PDATA   ENTREVISTAINTERNA.DATA%TYPE;
PANYO    DWNUMENTI.ANYO%TYPE;
PANYACTUAL DWNUMENTI.ANYO%TYPE;
PFIDSEU ENTREVISTAINTERNA.FIDSEU%TYPE;
num_reg integer;
num_ent integer;
num_ent_actual integer;

BEGIN
  PDATA:=:new.DATA;
  PFIDSEU:=:new.FIDSEU;
  -- Extraiem l'any de la data de l'entrevista
  SELECT EXTRACT(Year FROM PDATA) INTO PANYO FROM DUAL;
  SELECT EXTRACT(Year FROM SYSDATE) INTO PANYACTUAL FROM DUAL;
  IF INSERTING THEN
    -- ACTUALITZEM LA TAULA DWNUMENTI DEL CU15
    -- comprovem si esisteix l'any
    SELECT count(ANYO) INTO num_reg FROM DWNUMENTI WHERE ANYO = PANYO;
    IF num_reg=0 THEN
        INSERT INTO DWNUMENTI(ANYO, NUMENTREVISTESI) VALUES (PANYO,1);
    ELSE
       SELECT NUMENTREVISTESI INTO num_ent FROM DWNUMENTI WHERE ANYO=PANYO;
       UPDATE DWNUMENTI SET NUMENTREVISTESI=num_ent+1 WHERE ANYO = PANYO;
    END IF;
    -- ACTUALITXEM LA TAULA SEU I DWMENYSENTSEU DEL CU28 (si estem en l'any en curs)
    IF PANYO=PANYACTUAL THEN
      SELECT NUMENTANYACTUAL INTO num_ent_actual FROM SEU WHERE IDSEU=PFIDSEU;
      UPDATE SEU SET NUMENTANYACTUAL=num_ent_actual+1 WHERE IDSEU=PFIDSEU;
      PROC_DWMENYSENTSEU;
    END IF;
  END IF;
  IF UPDATING AND :new.DATABAIXA IS NOT NULL THEN
       -- ACTUALITZEM LA TAULA DWNUMENTI DEL CU15
       SELECT NUMENTREVISTESI INTO num_ent FROM DWNUMENTI WHERE ANYO=PANYO;
       UPDATE DWNUMENTI SET NUMENTREVISTESI=num_ent-1 WHERE ANYO = PANYO;
       -- ACTUALITXEM LA TAULA SEU I DWMENYSENTSEU DEL CU28 (si estem en l'any en curs)
      IF PANYO=PANYACTUAL THEN
        SELECT NUMENTANYACTUAL INTO num_ent_actual FROM SEU WHERE IDSEU=PFIDSEU;
        UPDATE SEU SET NUMENTANYACTUAL=num_ent_actual-1 WHERE IDSEU=PFIDSEU;
        PROC_DWMENYSENTSEU;
      END IF;
  END IF;
END DW_TRGENTREVISTAI;
/

-------------------------------------------------------------
--Nom        :   DW_TRGPROPCOMERCIAL
--Cas d's   :   CU18 - Import de propostes acceptades donat un any
--               CU19 - Comercial amb millor rtio
--               CU24 - Client amb ms propostes denegades
--Descripci :   Cada cop que es fa una actualirzaci a la taula PROPROSTACOMERCIAL
-- s'actualitzen les taules: DWIMPORTPROPACC, DWCOMMILLORRATIO, DWDENEGCLIENTS, DWTOPDENEGCLIENT, COMERCIAL
-------------------------------------------------------------
create or replace TRIGGER DW_TRGPROPCOMERCIAL 
AFTER INSERT OR UPDATE ON PROPOSTACOMERCIAL 
REFERENCING OLD AS OLD NEW AS NEW 
FOR EACH ROW 
DECLARE
PDATA   PROPOSTACOMERCIAL.DATAPROPOSTA%TYPE;
PANYO   Integer;
PIMPORT PROPOSTACOMERCIAL.IMPORT%TYPE;
ESTATOLD  PROPOSTACOMERCIAL.ESTAT%TYPE;
ESTATNEW  PROPOSTACOMERCIAL.ESTAT%TYPE;
PFIDCLIENT  PROPOSTACOMERCIAL.FIDCLIENT%TYPE;
PFIDCOMERCIAL  PROPOSTACOMERCIAL.FIDCOMERCIAL%TYPE;
PNOM CLIENT.NOM%TYPE;
num_reg Integer;
num_pres  Integer;
num_acc Integer;
imp_acc Float;
prop_deneg  Integer;
incr  Integer;

BEGIN
  PDATA:=:new.DATAPROPOSTA;
  ESTATOLD:=:old.ESTAT;
  ESTATNEW:=:new.ESTAT;
  PIMPORT:=:new.IMPORT;
  PFIDCLIENT:=:new.FIDCLIENT;
  PFIDCOMERCIAL:=:new.FIDCOMERCIAL;
  
  -- Extraiem l'any de la data de la proposta
  SELECT EXTRACT(Year FROM PDATA) INTO PANYO FROM DUAL;
  IF INSERTING THEN
    -- CU19 Actualitzem comptadors de la taula COMERCIAL
    SELECT NUMPRESENTADES, NUMACCEPTADES INTO num_pres, num_acc FROM COMERCIAL WHERE IDCOMERCIAL=PFIDCOMERCIAL;
    IF ESTATNEW='A' THEN incr:=1; ELSE incr:=0; END IF;
    UPDATE COMERCIAL SET NUMPRESENTADES=num_pres+1, NUMACCEPTADES=num_acc+incr WHERE IDCOMERCIAL=PFIDCOMERCIAL;
    -- Actualitzem la taula DWCOMMILLORRATIO amb el millor rtio si cal;
    PROC_DWCOMMILLORRATIO;
    -- ACTUALITZEM LA TAULA DWIMPORTPROPACC DEL CU18 (si s'escau)
    IF ESTATNEW='A' THEN 
      -- comprovem si esisteix l'any
      SELECT count(ANYO) INTO num_reg FROM DWIMPORTPROPACC WHERE ANYO = PANYO;
      -- si no existeix l'any inserim un nou registre
      IF num_reg=0 THEN
        INSERT INTO DWIMPORTPROPACC(ANYO, IMPORTACCEPTADES) VALUES (PANYO,PIMPORT);
      -- si ja existeix l'any, sumem l'import de la proposta acceptada    
      ELSE
       SELECT IMPORTACCEPTADES INTO imp_acc FROM DWIMPORTPROPACC WHERE ANYO=PANYO;
       UPDATE DWIMPORTPROPACC SET IMPORTACCEPTADES=imp_acc+PIMPORT WHERE ANYO = PANYO;
      END IF;
    END IF;
    -- ACTUALITZEM LA TAULA DWDENEGCLIENTS DEL CU24 (si s'escau)
    IF ESTATNEW='R' THEN
      -- comprovem si esisteix l'any i el client
      SELECT count(ANYO) INTO num_reg FROM DWDENEGCLIENTS WHERE ANYO = PANYO AND FIDCLIENT=PFIDCLIENT;
      -- si no existeix l'any i el client inserim un nou registre
      IF num_reg=0 THEN
      SELECT NOM INTO PNOM FROM CLIENT WHERE IDCLIENT=PFIDCLIENT;
      INSERT INTO DWDENEGCLIENTS(ANYO, FIDCLIENT, NOM, TOTALPROPDENEGADES) 
         VALUES (PANYO,PFIDCLIENT,PNOM ,1);
      PROC_DWTOPDENEGCLIENT(PANYO);
      -- si ja existeix l'any i el client, incrementem el comptador de propostes denegades  
      ELSE
       SELECT TOTALPROPDENEGADES INTO prop_deneg FROM DWDENEGCLIENTS WHERE ANYO=PANYO AND FIDCLIENT=PFIDCLIENT;
       UPDATE DWDENEGCLIENTS SET TOTALPROPDENEGADES=prop_deneg+1 WHERE ANYO = PANYO AND FIDCLIENT=PFIDCLIENT;
       PROC_DWTOPDENEGCLIENT(PANYO);
      END IF;
    END IF;
  END IF;
  -- Si s una baixa o modificaci
  IF UPDATING THEN
    -- si s una baixa
    IF :new.DATABAIXA IS NOT NULL THEN
     -- CU19 Actualitzem comptadors de la taula COMERCIAL
      IF ESTATOLD='A' THEN incr:=1; ELSE incr:=0; END IF;
      SELECT NUMPRESENTADES, NUMACCEPTADES INTO num_pres, num_acc FROM COMERCIAL WHERE IDCOMERCIAL=PFIDCOMERCIAL;
      UPDATE COMERCIAL SET NUMPRESENTADES=num_pres-1, NUMACCEPTADES=num_acc-incr WHERE IDCOMERCIAL=PFIDCOMERCIAL;
       -- Actualitzem la taula DWCOMMILLORRATIO amb el millor rtio si cal;
       PROC_DWCOMMILLORRATIO;
     -- ACTUALITZEM LA TAULA DWIMPORTPROPACC DEL CU18 (si s'escau)
     -- si era una proposta acceptada descomptarem l'import
      IF ESTATOLD='A' THEN
         SELECT IMPORTACCEPTADES INTO imp_acc FROM DWIMPORTPROPACC WHERE ANYO=PANYO;
         UPDATE DWIMPORTPROPACC SET IMPORTACCEPTADES=imp_acc-PIMPORT WHERE ANYO = PANYO;
      END IF;
      -- ACTUALITZEM LA TAULA DWDENEGCLIENTS DEL CU24 (si s'escau)
      -- si era una proposta rebutjada decrementem el comptador
      IF ESTATOLD='R' THEN
         SELECT TOTALPROPDENEGADES INTO prop_deneg FROM DWDENEGCLIENTS WHERE ANYO=PANYO AND FIDCLIENT=PFIDCLIENT;
         UPDATE DWDENEGCLIENTS SET TOTALPROPDENEGADES=prop_deneg-1 WHERE ANYO = PANYO AND FIDCLIENT=PFIDCLIENT;
         PROC_DWTOPDENEGCLIENT(PANYO);
      END IF;
    -- si s una modificaci 
    ELSE
      -- CU19 Actualitzem comptadors de la taula COMERCIAL
      IF ESTATNEW='A' AND (ESTATOLD!='A' OR ESTATOLD IS NULL )THEN
        SELECT NUMPRESENTADES, NUMACCEPTADES INTO num_pres, num_acc FROM COMERCIAL WHERE IDCOMERCIAL=PFIDCOMERCIAL;
        UPDATE COMERCIAL SET NUMACCEPTADES=num_acc+1 WHERE IDCOMERCIAL=PFIDCOMERCIAL;
        -- Actualitzem la taula DWCOMMILLORRATIO amb el millor rtio si cal;
        PROC_DWCOMMILLORRATIO;
      ELSE
        IF ESTATOLD='A' AND ESTATNEW!='A' THEN
          SELECT NUMPRESENTADES, NUMACCEPTADES INTO num_pres, num_acc FROM COMERCIAL WHERE IDCOMERCIAL=PFIDCOMERCIAL;
          UPDATE COMERCIAL SET NUMACCEPTADES=num_acc-1 WHERE IDCOMERCIAL=PFIDCOMERCIAL;
          -- Actualitzem la taula DWCOMMILLORRATIO amb el millor rtio si cal;
          PROC_DWCOMMILLORRATIO;
        END IF;
      END IF;    
      --CU18 -mirarem si l'estat de la proposta ha variat cap a acceptada per sumar l'import
      IF ESTATNEW='A' AND (ESTATOLD!='A' OR ESTATOLD IS NULL )THEN
        SELECT IMPORTACCEPTADES INTO imp_acc FROM DWIMPORTPROPACC WHERE ANYO=PANYO;
        UPDATE DWIMPORTPROPACC SET IMPORTACCEPTADES=imp_acc+PIMPORT WHERE ANYO = PANYO;
      --CU18 mirarem si l'estat de la proposta ha variat a no acceptada per restar l'import
      ELSE
         IF ESTATOLD='A' AND ESTATNEW!='A' THEN
           SELECT IMPORTACCEPTADES INTO imp_acc FROM DWIMPORTPROPACC WHERE ANYO=PANYO;
           UPDATE DWIMPORTPROPACC SET IMPORTACCEPTADES=imp_acc-PIMPORT WHERE ANYO = PANYO;
         END IF;
      END IF;
       --CU24 -mirarem si l'estat de la proposta ha variat cap a rebutjada per incrementar el comptador de denegades
      IF ESTATNEW='R' AND (ESTATOLD!='R' OR ESTATOLD IS NULL )THEN
         SELECT TOTALPROPDENEGADES INTO prop_deneg FROM DWDENEGCLIENTS WHERE ANYO=PANYO AND FIDCLIENT=PFIDCLIENT;
         UPDATE DWDENEGCLIENTS SET TOTALPROPDENEGADES=prop_deneg+1 WHERE ANYO = PANYO AND FIDCLIENT=PFIDCLIENT;
         PROC_DWTOPDENEGCLIENT(PANYO);
      --CU24 mirarem si l'estat de la proposta ha variat a no rebutjada per descrementar el comptador de denegades
      ELSE
         IF ESTATOLD='R' AND ESTATNEW!='R' THEN
           SELECT TOTALPROPDENEGADES INTO prop_deneg FROM DWDENEGCLIENTS WHERE ANYO=PANYO AND FIDCLIENT=PFIDCLIENT;
           UPDATE DWDENEGCLIENTS SET TOTALPROPDENEGADES=prop_deneg+1 WHERE ANYO = PANYO AND FIDCLIENT=PFIDCLIENT;
           PROC_DWTOPDENEGCLIENT(PANYO);
         END IF;
      END IF;
    END IF;
  END IF;  
END DW_TRGPROPCOMERCIAL;
/
-------------------------------------------------------------
--Nom        :   DW_TRGPROCESSEL
--Cas d's   :   CU16 - Percentatge de processos de selecci positius per any
--               CU21 - Top 10 dels nivell d'estudis d'un any
--               CU23 - Client que ms candidats ens ha acceptat
--Descripci :   Cada cop que es fa una actualitzaci de la taula PROCESSELECCIO 
-- s'actualitzen les taules: DWPROCSELPOSITIUS, DWTOTDEMESTUDIS, DWTOP10ESTUDIS, DWCLIENTMESACC, CLIENT
-------------------------------------------------------------
create or replace TRIGGER DW_TRGPROCESSEL
AFTER INSERT OR UPDATE ON PROCESSELECCIO
REFERENCING OLD AS old NEW AS new
FOR EACH ROW
DECLARE
  PDATA   PROCESSELECCIO.DATAINICI%TYPE;
  PANYO    DWPROCSELPOSITIUS.ANYO%TYPE;
  PANYACTUAL DWPROCSELPOSITIUS.ANYO%TYPE;
  RESULOLD  PROCESSELECCIO.RESULTAT%TYPE;
  RESULNEW  PROCESSELECCIO.RESULTAT%TYPE;
  PFIDESTUDIS PROCESSELECCIO.FIDESTUDIS%TYPE;
  PFIDCLIENT PROCESSELECCIO.FIDCLIENT%TYPE;
  PTIPUS  NIVELLESTUDIS.DESCRIPCIO%TYPE;
  num_reg integer;
  num_proc integer;
  num_pos	Integer;
  inc_pos integer;
  num_est integer;
  num_cand	Integer;

BEGIN
  PDATA:=:new.DATAINICI;
  RESULNEW:=:new.RESULTAT;
  RESULOLD:=:old.RESULTAT;
  PFIDESTUDIS:=:new.FIDESTUDIS;
  PFIDCLIENT:=:new.FIDCLIENT;
  SELECT (DESCRIPCIO) INTO PTIPUS FROM NIVELLESTUDIS WHERE IDESTUDIS=PFIDESTUDIS;
  IF RESULNEW='P' THEN
      inc_pos:=1;
  ELSE
      inc_pos:=0;
  END IF;
  -- Extraiem l'any de la data del procs de selecci
  SELECT EXTRACT(Year FROM PDATA) INTO PANYO FROM DUAL;
  SELECT EXTRACT(Year FROM SYSDATE) INTO PANYACTUAL FROM DUAL;
  IF INSERTING THEN
    -- ACTUALITZEM LA TAULA DWPROCSELPOSITIUS DEL CU16
    -- comprovem si esisteix l'any
    SELECT count(ANYO) INTO num_reg FROM DWPROCSELPOSITIUS WHERE ANYO = PANYO;
    IF num_reg=0 THEN
        INSERT INTO DWPROCSELPOSITIUS(ANYO, NUMPROCESSOS, NUMPOSITIUS) VALUES (PANYO,1,inc_pos);
    ELSE
       SELECT NUMPROCESSOS, NUMPOSITIUS INTO num_proc, num_pos FROM DWPROCSELPOSITIUS WHERE ANYO=PANYO;
       UPDATE DWPROCSELPOSITIUS SET NUMPROCESSOS=num_proc+1, NUMPOSITIUS=num_pos+inc_pos WHERE ANYO = PANYO;
    END IF;
    -- ACTUALITZEM LA TAULA DWTOTDEMESTUDIS I DWTOP10ESTUDIS DEL CU21
    -- comprovem si esisteix l'any i el codi de l'estudi
    SELECT count (*) INTO num_reg FROM DWTOTDEMESTUDIS WHERE ANYO = PANYO AND FIDESTUDIS=PFIDESTUDIS;
    IF num_reg=0 THEN
      INSERT INTO DWTOTDEMESTUDIS(ANYO, FIDESTUDIS, TIPUS, TOTALDEMANATSPROCES) VALUES (PANYO,PFIDESTUDIS,PTIPUS,1);
      PROC_DWTOP10ESTUDIS(PANYO);
    ELSE
      SELECT TOTALDEMANATSPROCES INTO num_est FROM DWTOTDEMESTUDIS WHERE ANYO = PANYO AND FIDESTUDIS=PFIDESTUDIS;
      UPDATE DWTOTDEMESTUDIS SET TOTALDEMANATSPROCES=num_est+1 WHERE ANYO = PANYO AND FIDESTUDIS=PFIDESTUDIS;
      PROC_DWTOP10ESTUDIS(PANYO);
    END IF;
    -- ACTUALITZEM LA TAULA CLIENT I DWCLIENTMESACC DEL CU23 (si el resultat s positiu)
    IF RESULNEW='P' THEN
      SELECT NUMCANDACCEPTATS INTO num_cand FROM CLIENT WHERE IDCLIENT=PFIDCLIENT;
      UPDATE CLIENT SET NUMCANDACCEPTATS=num_cand+1 WHERE IDCLIENT=PFIDCLIENT;
      PROC_DWCLIENTMESACC;
    END IF; 
  END IF;
  IF UPDATING THEN
    -- ACTUALITZEM LA TAULA CLIENT I DWCLIENTMESACC DEL CU23 
    SELECT NUMCANDACCEPTATS INTO num_cand FROM CLIENT WHERE IDCLIENT=PFIDCLIENT;
    IF :new.DATABAIXA IS NOT NULL THEN
       UPDATE CLIENT SET NUMCANDACCEPTATS=num_cand+1 WHERE IDCLIENT=PFIDCLIENT;
       PROC_DWCLIENTMESACC;
    ELSE
      IF RESULNEW='P' AND (RESULOLD!='P' OR RESULOLD IS NULL )THEN
        UPDATE CLIENT SET NUMCANDACCEPTATS=num_cand+1 WHERE IDCLIENT=PFIDCLIENT;
        PROC_DWCLIENTMESACC;
      ELSE
        IF RESULOLD='P' AND (RESULNEW!='P' OR RESULNEW IS NULL) THEN
          UPDATE CLIENT SET NUMCANDACCEPTATS=num_cand-1 WHERE IDCLIENT=PFIDCLIENT;
          PROC_DWCLIENTMESACC;
        END IF;
      END IF;
    END IF; 
    -- ACTUALITZEM LA TAULA DWNUMENTI DEL CU16
    SELECT NUMPROCESSOS, NUMPOSITIUS INTO num_proc, num_pos FROM DWPROCSELPOSITIUS WHERE ANYO=PANYO;
    IF :new.DATABAIXA IS NOT NULL THEN
      UPDATE DWPROCSELPOSITIUS SET NUMPROCESSOS=num_proc-1, NUMPOSITIUS=num_pos-inc_pos WHERE ANYO = PANYO;
    ELSE
      IF RESULNEW='P' AND (RESULOLD!='P' OR RESULOLD IS NULL )THEN
         UPDATE DWPROCSELPOSITIUS SET NUMPOSITIUS=num_pos+1 WHERE ANYO = PANYO;
      ELSE
        IF RESULOLD='P' AND (RESULNEW!='P' OR RESULNEW IS NULL) THEN
           UPDATE DWPROCSELPOSITIUS SET NUMPOSITIUS=num_pos-1 WHERE ANYO = PANYO;
        END IF;
      END IF;
    END IF;
    -- ACTUALITZEM LA TAULA DWTOTDEMESTUDIS I DWTOP10ESTUDIS DEL CU21
    SELECT TOTALDEMANATSPROCES INTO num_est FROM DWTOTDEMESTUDIS WHERE ANYO = PANYO AND FIDESTUDIS=PFIDESTUDIS;
    IF :new.DATABAIXA IS NOT NULL THEN
      UPDATE DWTOTDEMESTUDIS SET TOTALDEMANATSPROCES=num_est-1 WHERE ANYO = PANYO AND FIDESTUDIS=PFIDESTUDIS;
      PROC_DWTOP10ESTUDIS(PANYO);
    END IF;
  END IF;
END DW_TRGPROCESSEL;
/

-------------------------------------------------------------
--Nom        :   DW_TRGPROCCOM
--Cas d's   :   CU22 - Top 5 competencies en processos selecci
--Descripci :   Cada cop que es fa una actualitzaci de la taula PROCESSELCOMPETENCIA
-- s'actualitzen les taules: DWTOTDEMCOMPETENCIA I DWTOP5COMPETENCIA
------------------------------------------------------------
create or replace TRIGGER DW_TRGPROCCOM 
AFTER INSERT OR UPDATE ON PROCESSELCOMPETENCIA 
REFERENCING OLD AS old NEW AS new
FOR EACH ROW
DECLARE
PFIDPROCESSEL PROCESSELCOMPETENCIA.FIDPROCESSEL%TYPE;
PFIDCOMPETENCIA PROCESSELCOMPETENCIA.FIDCOMPETENCIA%TYPE;
PANYO  DWTOTDEMCOMPETENCIA.ANYO%TYPE;
PDATAINICI  PROCESSELECCIO.DATAINICI%TYPE;
PDESCRIPCIO COMPETENCIAPROFESSIONAL.DESCRIPCIO%TYPE;
num_reg Integer;
total_proc  Integer;

BEGIN
  PFIDPROCESSEL:=:new.FIDPROCESSEL;
  PFIDCOMPETENCIA:=:new.FIDCOMPETENCIA;
  -- Extraiem l'any de la data del procs de selecci
  SELECT EXTRACT(Year FROM DATAINICI) INTO PANYO 
    FROM (SELECT DATAINICI FROM PROCESSELECCIO WHERE IDPROCESSEL=PFIDPROCESSEL);
  -- Extraiem la descripci de la competncia professional
  SELECT DESCRIPCIO INTO PDESCRIPCIO FROM COMPETENCIAPROFESSIONAL WHERE IDCOMPETENCIA=PFIDCOMPETENCIA;
  IF INSERTING THEN
    -- ACTUALITZEM LA TAULA DWTOTDEMCOMPETENCIA I DWTOP5COMPETENCIA DEL CU22
    --Mirem si ja existeix el registre per a aquesta competncia i aquest any
    SELECT count(ANYO) INTO num_reg FROM DWTOTDEMCOMPETENCIA WHERE ANYO = PANYO AND FIDCOMPETENCIA=PFIDCOMPETENCIA;
    IF num_reg=0 THEN
      INSERT INTO DWTOTDEMCOMPETENCIA (ANYO, FIDCOMPETENCIA, DESCRIPCIO, TOTALDEMANATSPROCES)
        VALUES (PANYO, PFIDCOMPETENCIA, PDESCRIPCIO, 1);
      PROC_DWTOP5COMPETENCIA(PANYO);
    ELSE
      SELECT TOTALDEMANATSPROCES INTO total_proc FROM DWTOTDEMCOMPETENCIA WHERE ANYO=PANYO AND FIDCOMPETENCIA=PFIDCOMPETENCIA;
      UPDATE DWTOTDEMCOMPETENCIA SET TOTALDEMANATSPROCES=total_proc+1 WHERE ANYO = PANYO AND FIDCOMPETENCIA=PFIDCOMPETENCIA;
      PROC_DWTOP5COMPETENCIA(PANYO);
    END IF;
  END IF;
  IF UPDATING AND :new.DATABAIXA IS NOT NULL THEN
    -- ACTUALITZEM LA TAULA DWTOTDEMCOMPETENCIA I DWTOP5COMPETENCIA DEL CU22
    SELECT TOTALDEMANATSPROCES INTO total_proc FROM DWTOTDEMCOMPETENCIA WHERE ANYO=PANYO AND FIDCOMPETENCIA=PFIDCOMPETENCIA;
    UPDATE DWTOTDEMCOMPETENCIA SET TOTALDEMANATSPROCES=total_proc-1 WHERE ANYO = PANYO AND FIDCOMPETENCIA=PFIDCOMPETENCIA;
    PROC_DWTOP5COMPETENCIA(PANYO);
  END IF;
END DW_TRGPROCCOM;
/

-------------------------------------------------------------
--Nom        :   DW_TRGCANDIDAT 
--Cas d's   :   CU17 - Candidats no seleccionats en cap procs de selecci
--               CU20 - Procs de captaci amb ms candidats selseccionats en processos
--               CU25 - Candidats no seleccionats per cap client
--Descripci :   Cada cop que es fa una actualitzaci de la taula CANDIDAT
-- s'actualitzen les taules: DWTOTCANDIDATS, PROCESCAPTACIO, DWMILLORPROCCAP
------------------------------------------------------------
create or replace TRIGGER DW_TRGCANDIDAT
AFTER INSERT OR UPDATE ON CANDIDAT
REFERENCING OLD AS OLD NEW AS NEW
FOR EACH ROW
DECLARE
  SELCLIENTOLD  CANDIDAT.SELCLIENT%TYPE;
  SELCLIENTNEW  CANDIDAT.SELCLIENT%TYPE;
  NUMPROCOLD  CANDIDAT.NUMPROCESSEL%TYPE;
  NUMPROCNEW  CANDIDAT.NUMPROCESSEL%TYPE;
  PFIDPROCESCAP CANDIDAT.FIDPROCESCAP%TYPE;
  PTOTALCANDIDATS DWTOTCANDIDATS.TOTALCANDIDATS%TYPE;
  PTOTALSELPROCES DWTOTCANDIDATS.TOTALSELPROCES%TYPE;
  PTOTALSELCLIENT DWTOTCANDIDATS.TOTALSELCLIENT%TYPE;
  inc_client Integer;
  inc_proces Integer;
  num_reg integer;
  num_proc integer;
  num_cand  Integer;
  num_client  Integer;
  num_total_cand  Integer;

BEGIN
  SELCLIENTOLD:=:old.SELCLIENT;
  SELCLIENTNEW:=:new.SELCLIENT;
  NUMPROCOLD:=:old.NUMPROCESSEL;
  NUMPROCNEW:=:new.NUMPROCESSEL;
  PFIDPROCESCAP:=:new.FIDPROCESCAP;

  IF INSERTING THEN
    IF NUMPROCNEW>0 THEN inc_proces:=1;ELSE inc_proces:=0; END IF;
    IF SELCLIENTNEW='S' THEN inc_client:=1;ELSE inc_client:=0; END IF;
    -- ACTUALITZEM LA TAULA DWTOTCANDIDATS DEL CU17-CU25
    -- comprovem si esisteix el registre
    SELECT count (IDTOTCANDIDATS) INTO num_reg FROM DWTOTCANDIDATS;
    IF num_reg=0 THEN
        INSERT INTO DWTOTCANDIDATS(IDTOTCANDIDATS, TOTALCANDIDATS, TOTALSELPROCES, TOTALSELCLIENT)
           VALUES (1,1, inc_proces,inc_client);
    ELSE
        SELECT TOTALCANDIDATS, TOTALSELPROCES, TOTALSELCLIENT
          INTO PTOTALCANDIDATS, PTOTALSELPROCES, PTOTALSELCLIENT FROM DWTOTCANDIDATS WHERE IDTOTCANDIDATS=1;
        UPDATE DWTOTCANDIDATS SET TOTALCANDIDATS=PTOTALCANDIDATS+1, TOTALSELPROCES=PTOTALSELPROCES+inc_proces, TOTALSELCLIENT=PTOTALSELCLIENT+inc_client
          WHERE IDTOTCANDIDATS=1;
    END IF;
    -- ACTUALITZEM LA TAULA PROCESCAPTACIO CU20
      SELECT NUMACCPROCSEL INTO num_proc FROM PROCESCAPTACIO WHERE IDPROCESCAP=PFIDPROCESCAP;
      IF NUMPROCNEW>0 THEN
        UPDATE PROCESCAPTACIO SET NUMACCPROCSEL =num_proc+1 WHERE IDPROCESCAP=PFIDPROCESCAP;
        PROC_DWMILLORPROCCAP;
      END IF;
  END IF;
  -- si s una modificaci o una baixa
  IF UPDATING THEN
   -- recuperem els valors actuals dels comptadors
    SELECT TOTALCANDIDATS, TOTALSELPROCES, TOTALSELCLIENT
          INTO PTOTALCANDIDATS, PTOTALSELPROCES, PTOTALSELCLIENT FROM DWTOTCANDIDATS WHERE IDTOTCANDIDATS=1;
    -- si s una baixa
    IF :new.DATABAIXA IS NOT NULL THEN
        IF SELCLIENTNEW='S' THEN inc_client:=1; ELSE inc_client:=0; END IF;
        IF NUMPROCNEW>0 THEN inc_proces:=1;ELSE inc_proces:=0; END IF;
        UPDATE DWTOTCANDIDATS SET TOTALCANDIDATS=PTOTALCANDIDATS-1, TOTALSELPROCES=PTOTALSELPROCES-inc_proces, TOTALSELCLIENT=PTOTALSELCLIENT-inc_client
          WHERE IDTOTCANDIDATS=1;
         -- ACTUALITZEM LA TAULA PROCESCAPTACIO CU20
         SELECT NUMACCPROCSEL INTO num_proc FROM PROCESCAPTACIO WHERE IDPROCESCAP=PFIDPROCESCAP;
         UPDATE PROCESCAPTACIO SET NUMACCPROCSEL =num_proc-NUMPROCNEW WHERE IDPROCESCAP=PFIDPROCESCAP;
         PROC_DWMILLORPROCCAP;
    -- si s una modificaci
    ELSE
       IF SELCLIENTNEW='S' AND SELCLIENTOLD!='S' THEN inc_client:=1; ELSE inc_client:=0; END IF;
       IF NUMPROCNEW=1 AND NUMPROCOLD=0 THEN 
         inc_proces:=1;
       ELSE 
        IF NUMPROCOLD=1 AND NUMPROCNEW=0 THEN
          inc_proces:=-1; 
        ELSE  
          inc_proces:=0;
        END IF;
      END IF;  
      UPDATE DWTOTCANDIDATS SET TOTALSELPROCES=PTOTALSELPROCES+inc_proces, TOTALSELCLIENT=PTOTALSELCLIENT+inc_client WHERE IDTOTCANDIDATS=1;
      -- ACTUALITZEM LA TAULA PROCESCAPTACIO CU20
      SELECT NUMACCPROCSEL INTO num_proc FROM PROCESCAPTACIO WHERE IDPROCESCAP=PFIDPROCESCAP;
      IF NUMPROCNEW>NUMPROCOLD THEN
        UPDATE PROCESCAPTACIO SET NUMACCPROCSEL =num_proc+1 WHERE IDPROCESCAP=PFIDPROCESCAP;
        PROC_DWMILLORPROCCAP;
      END IF;
      IF NUMPROCOLD>NUMPROCNEW THEN
        UPDATE PROCESCAPTACIO SET NUMACCPROCSEL =num_proc-1 WHERE IDPROCESCAP=PFIDPROCESCAP;
        PROC_DWMILLORPROCCAP;
      END IF;
    END IF;
  END IF;
END DW_TRGCANDIDAT;
/
