/* IMPORTANT: s necessari estar connectat amb l'usuari ECOLLADOF amb password 12345678 abans d'executar aquest script                                           */
/* Aquest script cont els procediments que mostren per pantalla les consultes demanades pel client i que corresponen */
/*  al casos d's del CU15 al CU28. Com les dades ja estan calculade noms s'han de fer SELECTs i mostrar les dades   */

/***********************************************************/
/* PROCEDIMENTS PER A LES CONSULTES DEL DW                 */
/***********************************************************/

-------------------------------------------------------------
--Nom        :   PROC_CU15
--Descripci :   Nmero d'entrevistes internes per any
-------------------------------------------------------------
create or replace PROCEDURE PROC_CU15 (
 PANYO      In   DWNUMENTI.ANYO%Type,
 PRSP      Out  Nocopy Varchar2)
IS

param_input Varchar2(300);
codi_error  Integer;
num_ent     DWNUMENTI.NUMENTREVISTESI%Type;

BEGIN
param_input := 'PANYO= ' || PANYO;
PRSP := 'OK';
-- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT NUMENTREVISTESI INTO num_ent
          FROM DWNUMENTI
          WHERE ANYO = PANYO;

   dbms_output.put_line('Nmero d''entrevistes realitzades internament donat un any');
   dbms_output.put_line('-----------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('ANY    Nmero d''entrevistes');
   dbms_output.put_line('-----  ---------------------');
   dbms_output.put_line(PANYO || '   ' || num_ent);

  INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);

  Commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
End;
/

-------------------------------------------------------------
--Nom        :   PROC_CU16
--Descripci :   Percentatge de processos de selecci positius per any
-------------------------------------------------------------
create or replace PROCEDURE PROC_CU16 (
 PANYO      In   DWPROCSELPOSITIUS.ANYO%Type,
 PRSP      Out  Nocopy Varchar2)
IS

param_input Varchar2(300);
codi_error  Integer;
percentatge     DWPROCSELPOSITIUS.PERCPOSITIUS%Type;

BEGIN
param_input := 'PANYO= ' || PANYO;
PRSP := 'OK';
-- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT PERCPOSITIUS INTO percentatge
          FROM DWPROCSELPOSITIUS
          WHERE ANYO = PANYO;

   dbms_output.put_line('Percentatge de processos de selecci amb resultat positiu donat un any');
   dbms_output.put_line('----------------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('ANY    Percentatge de positius');
   dbms_output.put_line('-----  ---------------------');
   dbms_output.put_line(PANYO || '   ' || percentatge);

  INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);

  Commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
End;
/

-------------------------------------------------------------
--Nom        :   PROC_CU17
--Descripci :   Candidats no seleccionats en cap procs de selecci
-------------------------------------------------------------
CREATE OR REPLACE PROCEDURE PROC_CU17 (
PRSP      Out  Nocopy Varchar2)
IS

codi_error  Integer;
PPERNOSELPROCES DWTOTCANDIDATS.PERNOSELPROCES%TYPE;

BEGIN
   PRSP:='OK';
   -- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT PERNOSELPROCES INTO PPERNOSELPROCES FROM DWTOTCANDIDATS WHERE IDTOTCANDIDATS = 1;
   dbms_output.put_line('Percentatge de candidats que no han estat seleccionats en cap procs');
   dbms_output.put_line('---------------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('Percentatge de candidats no seleccionats: ' || PPERNOSELPROCES || '%');

   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);
   commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
End;
/


-------------------------------------------------------------
--Nom        :   PROC_CU18
--Descripci :   Import de propostes acceptades donat un any
-------------------------------------------------------------
CREATE OR REPLACE PROCEDURE PROC_CU18 (
 PANYO      In   DWIMPORTPROPACC.ANYO%Type,
 PRSP      Out  Nocopy Varchar2)
IS

param_input Varchar2(300);
codi_error  Integer;
import_acc     DWIMPORTPROPACC.IMPORTACCEPTADES%Type;

BEGIN
param_input := 'PANYO= ' || PANYO;
PRSP := 'OK';
-- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT IMPORTACCEPTADES INTO import_acc
          FROM DWIMPORTPROPACC
          WHERE ANYO = PANYO;

   dbms_output.put_line('Import de propostes comercials acceptades donat un any');
   dbms_output.put_line('-----------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('ANY    Import acceptades');
   dbms_output.put_line('-----  ---------------------');
   dbms_output.put_line(PANYO || '   ' || import_acc);

  INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);

  Commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
End;
/

-------------------------------------------------------------
--Nom        :   PROC_CU19
--Descripci :   Comercial amb millor rtio
-------------------------------------------------------------
create or replace PROCEDURE PROC_CU19 (
PRSP      Out  Nocopy Varchar2)
IS

codi_error  Integer;
PNOM  DWCOMMILLORRATIO.NOMCOMERCIAL%TYPE;
PRATIO  Float;
PNUMENT Integer;

BEGIN
   PRSP:='OK';
   -- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT NOMCOMERCIAL, RATIO INTO PNOM, PRATIO FROM DWCOMMILLORRATIO WHERE IDCOMMILLORRATIO = 1;
   dbms_output.put_line('Comercial amb millor rtio de propostes comercials');
   dbms_output.put_line('---------------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('Nom Comercial: ' || PNOM);
   dbms_output.put_line('Rtio: ' || PRATIO);

   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);
   commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
End;
/

-------------------------------------------------------------
--Nom        :   PROC_CU20
--Descripci :   Procs de captaci amb ms candidats selseccionats en processos
-------------------------------------------------------------
create or replace PROCEDURE PROC_CU20 (
PRSP      Out  Nocopy Varchar2)
IS

codi_error  Integer;
PTIPUS DWMILLORPROCCAP.TIPUS%TYPE;
PNUMCAND Integer;

BEGIN
   PRSP:='OK';
   -- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT TIPUS, TOTALPROCESSEL INTO PTIPUS, PNUMCAND FROM DWMILLORPROCCAP WHERE IDMILLORPROCCAP = 1;
   dbms_output.put_line('Procs de captaci que ms candidats han estat seleccionats en processos de selecci');
   dbms_output.put_line('---------------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('Procs de captaci: ' || PTIPUS);
   dbms_output.put_line('Total candidats: ' || PNUMCAND);

   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);
   commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
End;
/
-------------------------------------------------------------
--Nom        :   PROC_CU21
--Descripci :   Top 10 dels nivell d'estudis d'un any
-------------------------------------------------------------
create or replace PROCEDURE PROC_CU21 (
 PANYO      In   DWTOP10ESTUDIS.ANYO%Type,
 PRSP      Out  Nocopy Varchar2)
IS

param_input Varchar2(300);
codi_error  Integer;
-- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
CURSOR cur_estudis IS
     SELECT TOTAL, TIPUS FROM DWTOP10ESTUDIS WHERE ANYO=PANYO ORDER BY TOTAL DESC, TIPUS;

BEGIN
param_input := 'PANYO= ' || PANYO;
PRSP := 'OK';

   dbms_output.put_line('TOP 10 estudis ms demanats en els processos de selecci');
   dbms_output.put_line('-----------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('ANY    Total   Tipus');
   dbms_output.put_line('-----  ------  ----------------------------  ------');
   FOR i in cur_estudis LOOP
    dbms_output.put_line(PANYO || '   ' || i.TOTAL || '       ' || i.TIPUS);
   END LOOP;


  INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);

  Commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
End;
/

-------------------------------------------------------------
--Nom        :   PROC_CU22
--Descripci :   Top 5 competencies en processos selecci
-------------------------------------------------------------
create or replace PROCEDURE PROC_CU22 (
 PANYO      In   DWTOP5COMPETENCIA.ANYO%Type,
 PRSP      Out  Nocopy Varchar2)
IS

param_input Varchar2(300);
codi_error  Integer;
-- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
CURSOR cur_comp IS
     SELECT TOTAL, DESCRIPCIO FROM DWTOP5COMPETENCIA WHERE ANYO=PANYO ORDER BY TOTAL DESC, DESCRIPCIO;

BEGIN
param_input := 'PANYO= ' || PANYO;
PRSP := 'OK';
   dbms_output.put_line('TOP 5 competncies ms demanades en processos de selecci');
   dbms_output.put_line('-----------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('ANY    Total   Descripcio');
   dbms_output.put_line('-----  ------  ----------------------------  ------');
   FOR i in cur_comp LOOP
    dbms_output.put_line(PANYO || '   ' || i.TOTAL || '       ' || i.DESCRIPCIO);
   END LOOP;


  INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);

  Commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
End;
/

-------------------------------------------------------------
--Nom        :   PROC_CU23
--Descripci :   Client que ms candidats ens ha acceptat
-------------------------------------------------------------
create or replace PROCEDURE PROC_CU23 (
PRSP      Out  Nocopy Varchar2)
IS

codi_error  Integer;
PNOM DWCLIENTMESACC.NOM%TYPE;
PTOTALCAND Integer;

BEGIN
   PRSP:='OK';
   -- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT NOM, TOTALCANDACCEPTATS INTO PNOM, PTOTALCAND FROM DWCLIENTMESACC WHERE IDCLIENTMESACC= 1;
   dbms_output.put_line('Client que ms candidats ens ha acceptat fins ara');
   dbms_output.put_line('---------------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('Nom client: ' || PNOM);
   dbms_output.put_line('Nmero d candidats acceptats: ' || PTOTALCAND);

   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);
   commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
End;
/

-------------------------------------------------------------
--Nom        :   PROC_CU24
--Descripci :   Client amb ms propostes denegades
-------------------------------------------------------------
CREATE OR REPLACE PROCEDURE PROC_CU24 (
 PANYO      In   DWTOPDENEGCLIENT.ANYO%Type,
 PRSP      Out  Nocopy Varchar2)
IS

param_input Varchar2(300);
codi_error  Integer;
PNOM  DWTOPDENEGCLIENT.NOM%TYPE;
PTOTAL  DWTOPDENEGCLIENT.TOTAL%TYPE;

BEGIN
param_input := 'PANYO= ' || PANYO;
PRSP := 'OK';
-- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT NOM, TOTAL INTO PNOM, PTOTAL FROM DWTOPDENEGCLIENT WHERE ANYO=PANYO;
   dbms_output.put_line('Client que ms propostes ens ha denegat');
   dbms_output.put_line('-----------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('ANY    Total   Nom');
   dbms_output.put_line('-----  ------  ----------------------------  ------');
   dbms_output.put_line(PANYO || '   ' || PTOTAL || '       ' || PNOM);
  
  INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);

  Commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, SUBSTR(param_input,1,300), PRSP, SYSDATE);
    Commit;
End;
/

-------------------------------------------------------------
--Nom        :   PROC_CU25
--Descripci :   Candidats no seleccionats per cap client
-------------------------------------------------------------
CREATE OR REPLACE PROCEDURE PROC_CU25 (
PRSP      Out  Nocopy Varchar2)
IS

codi_error  Integer;
PPERNOSELCLIENT DWTOTCANDIDATS.PERNOSELCLIENT%TYPE;

BEGIN
   PRSP:='OK';
   -- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT PERNOSELCLIENT INTO PPERNOSELCLIENT FROM DWTOTCANDIDATS WHERE IDTOTCANDIDATS = 1;
   dbms_output.put_line('Percentatge de candidats que no han estat seleccionats per un client');
   dbms_output.put_line('---------------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('Percentatge de candidats no seleccionats: ' || PPERNOSELCLIENT || '%');

   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);
   commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
End;
/


-------------------------------------------------------------
--Nom        :   PROC_CU26
--Descripci :   Comercial que ha realitzat ms visites en l'any actual
-------------------------------------------------------------
create or replace PROCEDURE PROC_CU26 (
PRSP      Out  Nocopy Varchar2)
IS

codi_error  Integer;
PNOM DWVISITCOMERCIAL.NOM%TYPE;
PTOTAL Integer;

BEGIN
   PRSP:='OK';
   -- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT NOM, TOTAL INTO PNOM, PTOTAL FROM DWVISITCOMERCIAL WHERE IDVISITCOM = 1;
   dbms_output.put_line('Comercial que ms visites ha realitzat');
   dbms_output.put_line('---------------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('Nom Comercial: ' || PNOM);
   dbms_output.put_line('Total visites: ' || PTOTAL);

   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);
   commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
End;
/
-------------------------------------------------------------
--Nom        :   PROC_CU27
--Descripci :   Procs de captaci que ms candidats ha proporcionat als clients
-------------------------------------------------------------
CREATE OR REPLACE PROCEDURE PROC_CU27 (
PRSP      Out  Nocopy Varchar2)
IS

codi_error  Integer;
PTIPUS DWCAPCANDCLIENTS.TIPUS%TYPE;
PNUMCAND Integer;

BEGIN
   PRSP:='OK';
   -- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT TIPUS, NUMCAND INTO PTIPUS, PNUMCAND FROM DWCAPCANDCLIENTS WHERE IDCAPCANDCLIENTS = 1;
   dbms_output.put_line('Procs de captaci que ms candidats han seleccionat els clients aquest any');
   dbms_output.put_line('---------------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('Procs de captaci: ' || PTIPUS);
   dbms_output.put_line('Total candidats: ' || PNUMCAND);

   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);
   commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
End;
/
-------------------------------------------------------------
--Nom        :   PROC_CU28
--Descripci :   Seu amb menys entrevistes internes
-------------------------------------------------------------
create or replace PROCEDURE PROC_CU28 (
PRSP      Out  Nocopy Varchar2)
IS

codi_error  Integer;
PFIDSEU Integer;
PNUMENT Integer;

BEGIN
   PRSP:='OK';
   -- Es seleccionen les dades de la taula del magatzem de dades i es mostren per pantalla
   SELECT FIDSEU, NUMENT INTO PFIDSEU, PNUMENT FROM DWMENYSENTSEU WHERE IDMENYSENTSEU = 1;
   dbms_output.put_line('Codi de la Seu que ha fet menys entrevistes internes en l''any actual');
   dbms_output.put_line('---------------------------------------------------------------------');
   dbms_output.put_line('');
   dbms_output.put_line('Codi seu: ' || PFIDSEU);
   dbms_output.put_line('Nmero d''entrevistes: ' || PNUMENT);

   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
  Dbms_output.Put_line(PRSP);
   commit;
-- tractament de les excepcions
Exception
  WHEN NO_DATA_FOUND THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
   INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
  WHEN Others THEN
    codi_error := SQLCODE;
    PRSP:= Substr('ERROR: ' || codi_error ||' ' || SQLERRM ,1,50);
    Dbms_output.Put_line(PRSP);
    Rollback;
    INSERT INTO ECOLLADOF.LOG(NOMPROCEDIMENT, PARAMENTRADA, RSP, DATAEXECUCIO)
      VALUES($$PLSQL_UNIT, NULL, PRSP, SYSDATE);
    Commit;
End;
/


