/* IMPORTANT: s necessari estar connectat amb l'usuari ECOLLADOF amb password 12345678 abans d'executar aquest script             */
/* En aquest script es realitzen altes, baixes i modificacions a totes les taules de la base de dades operacional                  */
/* per tal de testejar el seu correcte funcionament. S'han forat operacions correctes i operacions que provoquen excepcions.      */

SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
/***********************************************************/
/*         1- Test taula RESPONSABLE             */
/***********************************************************/
-- Alta Responsalbe amd dades correctes - OK
PROC_A_RESPONSABLE('Carles Garcia','Carrer Girona, 10', 'Barcelona', RSP);
PROC_A_RESPONSABLE('Marta Prez','Carrer Tarragona, 20', 'Barcelona', RSP);
PROC_A_RESPONSABLE('Sergio Antuvi','Carrer Barcelona, 30', 'Barcelona', RSP);
PROC_A_RESPONSABLE('Mireia Robles','Carrer Lleida, 40', 'Barcelona', RSP);
PROC_A_RESPONSABLE('Mercedes Prado','Carrer Muntaner, 50', 'Barcelona', RSP);
-- Alta Responsable amb el camp NOM a NULL - ERROR CONTROLAT
PROC_A_RESPONSABLE(NULL,'Carrer Girona, 20', 'Barcelona', RSP);
-- Baixa Responsable que no existeix - ERROR CONTROLAT
PROC_B_RESPONSABLE(999, RSP);
-- Baixa Responsable que t una seu associada - ERROR CONTROLAT
PROC_B_RESPONSABLE(1, RSP);
-- Baixa Responsable correcta - OK
PROC_B_RESPONSABLE(15, RSP);
-- Baixa Responsable ja donat de baixa - ERROR CONTROLAT
PROC_B_RESPONSABLE(15, RSP);
-- Modificaci Responsable ja donat de baixa - ERROR CONTROLAT
PROC_M_RESPONSABLE(15, 'Mercedes Prado','Carrer Muntaner, 50', 'Tarragona', RSP);
-- Modificaci Responsable que no existeix - ERROR CONTROLAT
PROC_M_RESPONSABLE(999, 'Mercedes Prado','Carrer Muntaner, 50', 'Tarragona', RSP);
-- Modificaci Responsable amb valors incorrectes a NULL - ERROR CONTROLAT
PROC_M_RESPONSABLE(10,NULL,'Carrer Girona, 10', 'Barcelona', RSP);
-- Modificaci Responsable correcta
PROC_M_RESPONSABLE(12,'Marta Prez','Carrer Tarragona, 20', 'Tarragona', RSP);

/***********************************************************/
/*         2- Test taula NIVELLESTUDIS           */
/***********************************************************/
-- Alta NivellEstudis amb dades correctes - OK
PROC_A_NIVELLESTUDIS('Doctorat en Informtica', RSP);
PROC_A_NIVELLESTUDIS('Doctorat en Telecomunicacions', RSP);
PROC_A_NIVELLESTUDIS('Doctorat en Filosofia', RSP);
PROC_A_NIVELLESTUDIS('Doctorat en Matemtiques', RSP);
PROC_A_NIVELLESTUDIS('Doctorat en Cincies Poltiques', RSP);
-- Alta NivellEstudis amb descripci a NULL - ERROR CONTROLAT
PROC_A_NIVELLESTUDIS(NULL, RSP);
-- Baixa NivellEstudis correcta - OK
PROC_B_NIVELLESTUDIS(25, RSP);
-- Baixa NivellEstudis ja donada de baixa - ERROR CONTROLAT
PROC_B_NIVELLESTUDIS(25, RSP);
-- Baixa NivellEstudis que no existeix - ERROR CONTROLAT
PROC_B_NIVELLESTUDIS(999, RSP);
-- Baixa NivellEstudis que t candidats associats - ERROR CONTROLAT
PROC_B_NIVELLESTUDIS(1, RSP);
-- Modificaci NivellEstudis que no existeix - ERROR CONTROLAT
PROC_M_NIVELLESTUDIS(999, 'Doctorat en Filologia Anglesa', RSP);
-- Modificaci NivellEstudis que ja est donat de baixa - ERROR CONTROLAT
PROC_M_NIVELLESTUDIS(25, 'Doctorat en Filologia Anglesa', RSP);
-- Modificaci NivellEstudis amb valor NULL incorrecte - ERROR CONTROLAT
PROC_M_NIVELLESTUDIS(2, NULL, RSP);


/***********************************************************/
/*         3- Test taula COMPETENCIAPROFESSIONAL */
/***********************************************************/
-- Alta CompetenciaProfessional amb dades correctes - OK
PROC_A_COMPETENCIAPROFESSIONAL('Rus nivell bsic', '01/01/2016', RSP);
PROC_A_COMPETENCIAPROFESSIONAL('Rus nivell mig', '01/01/2016', RSP);
PROC_A_COMPETENCIAPROFESSIONAL('Rus nivell avanat', '01/01/2016', RSP);
PROC_A_COMPETENCIAPROFESSIONAL('rab nivell bsic', '01/01/2016', RSP);
PROC_A_COMPETENCIAPROFESSIONAL('rab nivell mig', '01/01/2016', RSP);
PROC_A_COMPETENCIAPROFESSIONAL('rab nivell avanat', '01/01/2016', RSP);
-- Alta CompetenciaProfessional amb camps a NULL no permesos - ERROR CONTROLAT
PROC_A_COMPETENCIAPROFESSIONAL('Rus nivell bsic', NULL, RSP);
-- Baixa CompetenciaProfessional amb dades correctes - OK
PROC_B_COMPETENCIAPROFESSIONAL(25, RSP);
-- Baixa CompetenciaProfessional ja donada de baixa - ERROR CONTROLAT
PROC_B_COMPETENCIAPROFESSIONAL(25, RSP);
-- Baixa CompetenciaProfessional que no existeix - ERROR CONTROLAT
PROC_B_COMPETENCIAPROFESSIONAL(999, RSP);
-- Baixa CompetenciaProfessionalamb candidat associat - ERROR CONTROLAT
PROC_B_COMPETENCIAPROFESSIONAL(2, RSP);
-- Baixa CompetenciaProfessional amb candidat o procs de selecci associat - ERROR CONTROLAT
PROC_B_COMPETENCIAPROFESSIONAL(5, RSP);
-- Modificaci CompetenciaProfessional amb dades correctes - OK
PROC_M_COMPETENCIAPROFESSIONAL(22,'Rus nivell bsic', '30/01/2016', RSP);
-- Modificaci CompetenciaProfessional ja donada de baixa - ERROR CONTROLAT
PROC_M_COMPETENCIAPROFESSIONAL(25,'rab nivell bsic', '15/01/2016', RSP);
-- Modificaci CompetenciaProfessional que no existeix - ERROR CONTROLAT
PROC_M_COMPETENCIAPROFESSIONAL(999,'Nova competncia', '20/01/2016', RSP);
-- Modificaci CompetenciaProfessional amb camps a NULL no permesos - ERROR CONTROLAT
PROC_M_COMPETENCIAPROFESSIONAL(22,NULL, '30/01/2016', RSP);

/***********************************************************/
/*         4- Test taula SEU                     */
/***********************************************************/
-- Alta Seu amb dades correctes - OK
PROC_A_SEU(1, 'Vic', '08500', 'Carrer major', '01/01/2016', RSP);
PROC_A_SEU(2, 'Ripoll', '08600', 'Carrer major', '01/01/2016', RSP);
PROC_A_SEU(3, 'Tremp', '08700', 'Carrer major', '01/01/2016', RSP);
PROC_A_SEU(4, 'Berga', '08800', 'Carrer major', '01/01/2016', RSP);
PROC_A_SEU(5, 'Reus', '08900', 'Carrer major', '01/01/2016', RSP);
-- Alta Seu amb camps a NULL no permesos - ERROR CONTROLAT
PROC_A_SEU(6, 'Barcelona', '08003', 'Carrer major', NULL, RSP);
-- Alta Seu amb codi Responsable donar de baixa o que no existeix - ERROR CONTROLAT
PROC_A_SEU(15, 'Barcelona', '08003', 'Carrer major', '01/01/2016', RSP);
-- Baixa Seu amb dades correctes - OK
PROC_B_SEU(15, RSP);
-- Baixa Seu ja donada de baixa - ERROR CONTROLAT
PROC_B_SEU(15, RSP);
-- Baixa Seu que no existeix - ERROR CONTROLAT 
PROC_B_SEU(999, RSP);
-- Baixa Seu amb candidat o client o entrevista o comercial associat - ERROR CONTROLAT
PROC_B_SEU(1, RSP);
-- Baixa Seu amb candidat o client o entrevista o comercial associat - ERROR CONTROLAT
PROC_B_SEU(2, RSP);
-- Baixa Seu amb candidat o client o entrevista o comercial associat - ERROR CONTROLAT
PROC_B_SEU(3, RSP);
-- Baixa Seu amb candidat o client o entrevista o comercial associat - ERROR CONTROLAT
PROC_B_SEU(4, RSP);
-- Modificaci Seu amb dades correctes - OK
PROC_M_SEU(11,1, 'Vic', '08500', 'Carrer major', '01/01/2016', RSP);
-- Modificaci Seu ja donada de baixa - ERROR CONTROLAT
PROC_M_SEU(15, 1, 'Vic', '08500', 'Carrer major', '01/01/2016', RSP);
-- Modificaci Seu que no existeix - ERROR CONTROLAT 
PROC_M_SEU(999, 1, 'Vic', '08500', 'Carrer major', '01/01/2016', RSP);
-- Modificaci Seu amb camps a NULL no permesos - ERROR CONTROLAT
PROC_M_SEU(11, NULL, 'Vic', '08500', 'Carrer major', '01/01/2016', RSP);
-- Moficiaci Seu amb codi Responsable donat de baixa o que no existeix - ERROR CONTROLAT
PROC_M_SEU(11, 15, 'Vic', '08500', 'Carrer major', '01/01/2016', RSP);

/***********************************************************/
/*         5- Test taula COMERCIAL               */
/***********************************************************/
-- Alta Comercial amb dades correctes - OK
PROC_A_COMERCIAL(11,'Anna Argull', 'Carrer Arag', 'Alacant',RSP);
PROC_A_COMERCIAL(12,'Eva Escusol', 'Carrer Entena', 'Esplugues',RSP);
PROC_A_COMERCIAL(13,'Irina Izquierdo', 'Carrer Indstria', 'Igualada',RSP);
PROC_A_COMERCIAL(14,'Olga Osorio', 'Carrer Oviedo', 'Os de Civs',RSP);
PROC_A_COMERCIAL(10,'Ulma Ubeda', 'Carrer Uni', 'Ulldecona',RSP);
-- Alta Comercial amb dades a NULL no permeses - ERROR CONTROLAT 
PROC_A_COMERCIAL(12,NULL, 'Carrer Uni', 'Ulldecona',RSP);
-- Alta Comercial am Seu donada de baixa o que no exisetix - ERROR CONTROLAT
PROC_A_COMERCIAL(15,'Blanca Blasco', 'Carrer Berln', 'Barcelona',RSP);
-- Baixa Comercial amb dades correctes - OK
PROC_B_COMERCIAL(51, RSP);
-- Baixa Comercial ja donat de baixa - ERROR CONTROLAT
PROC_B_COMERCIAL(51,RSP);
-- Baixa Comercial que no existeix - ERROR CONTROLAT
PROC_B_COMERCIAL(999, RSP);
-- Baixa Comercial que t clients o visites o propostes associats - ERROR CONTROLAT
PROC_B_COMERCIAL(1, RSP);
-- Baixa Comercial que t clients o visites o propostes associats - ERROR CONTROLAT
PROC_B_COMERCIAL(2, RSP);
-- Baixa Comercial que t clients o visites o propostes associats - ERROR CONTROLAT
PROC_B_COMERCIAL(3, RSP);
-- Modificaci Comercial amb dades correctes - OK
PROC_M_COMERCIAL(12,13, 'Marga Escusol', 'Carrer Entena', 'Esplugues', RSP);
-- Modificaci Comercial ja donat de baixa - ERROR CONTROLAT
PROC_M_COMERCIAL(51,8, 'Ulma Ubeda', 'Carrer Uni', 'Ulldecona',RSP);
-- Modificaci Comercial que no existeix - ERROR CONTROLAT
PROC_M_COMERCIAL(999, 8, 'Ulma Ubeda', 'Carrer Uni', 'Ulldecona', RSP);
-- Modificaci Comercial amb dades a NULL no permeses - ERROR CONTROLAT 
PROC_M_COMERCIAL(52, 13, NULL, 'Carrer Uni', 'Ulldecona', RSP);
-- Modificaci Comercial amb Seu donada de baixa o que no exisetix - ERROR CONTROLAT
PROC_M_COMERCIAL(53, 15, 'Ulma Ubeda', 'Carrer Uni', 'Ulldecona', RSP);

/***********************************************************/
/*         6- Test taula CLIENT                  */
/***********************************************************/
PROC_A_CLIENT(11, 52,'Gemma Vzquez', 'Plaa  Nobiliari blau 76, 4', 'Esplugas de Llobregat',  RSP);
PROC_A_CLIENT(12, 53, 'Alba Vzquez', 'Plaa  Nobiliari verd 76, 4', 'Esplugas de Llobregat', RSP);
PROC_A_CLIENT(13, 54, 'Irene Vzquez', 'Plaa  Nobiliari vermell 76, 4', 'Esplugas de Llobregat', RSP);
PROC_A_CLIENT(14, 55, 'Isabel Vzquez', 'Plaa  Nobiliari lila 76, 4', 'Esplugas de Llobregat', RSP);
PROC_A_CLIENT(10, 50, 'Nria Vzquez', 'Plaa  Nobiliari groc 76, 4', 'Esplugas de Llobregat', RSP);
-- Alta Client amb dades a NULL no permeses - ERROR CONTROLAT
PROC_A_CLIENT(10, 50, NULL, 'Plaa  Nobiliari groc 76, 4', 'Esplugas de Llobregat', RSP);
-- Alta Client amb seu donada de baixa o que no existeix- ERROR CONTROLAT
PROC_A_CLIENT(15, 50, 'Rosa Marco', 'Plaa  Nobiliari groc 76, 4', 'Esplugas de Llobregat', RSP);
-- Alta Client amb comercial donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_CLIENT(12, 51, 'Rosa Marco', 'Plaa  Nobiliari groc 76, 4', 'Esplugas de Llobregat', RSP);
-- Baixa Client amb dades correctes - OK
PROC_B_CLIENT(301, RSP);
-- Baixa Client ja donat de baixa - ERROR CONTROLAT
PROC_B_CLIENT(301, RSP);
-- Baixa Client que no existeix - ERROR CONTROLAT
PROC_B_CLIENT(999, RSP);
-- Baixa Client amb entrevistes, visites, propostes o processos associats- ERROR CONTROLAT
PROC_B_CLIENT(1,RSP);
-- Baixa Client amb entrevistes, visites, propostes o processos associats- ERROR CONTROLAT
PROC_B_CLIENT(2,RSP);
-- Baixa Client amb entrevistes, visites, propostes o processos associats- ERROR CONTROLAT
PROC_B_CLIENT(3,RSP);
-- Baixa Client amb entrevistes, visites, propostes o processos associats- ERROR CONTROLAT
PROC_B_CLIENT(4,RSP);
-- Modificaci Client amb dades correctes - OK
PROC_M_CLIENT(305, 10, 50, 'Marta Vzquez', 'Plaa  Nobiliari groc 76, 4', 'Esplugas de Llobregat', RSP);
-- Modificaci Client ja donat de baixa - ERROR CONTROLAT
PROC_M_CLIENT(301, 10, 50, 'Marta Vzquez', 'Plaa  Nobiliari groc 76, 4', 'Esplugas de Llobregat', RSP);
-- Modificaci Client que no existeix - ERROR CONTROLAT
PROC_M_CLIENT(999, 10, 50, 'Marta Vzquez', 'Plaa  Nobiliari groc 76, 4', 'Esplugas de Llobregat', RSP);
-- Modificaci Client amb camps a NULL no permesos - ERROR CONTROLAT
PROC_M_CLIENT(305, 10, 50, NULL, 'Plaa  Nobiliari groc 76, 4', 'Esplugas de Llobregat', RSP);
-- Modificaci Client amb seu donada de baixa o que no existeix- ERROR CONTROLAT
PROC_M_CLIENT(305, 15, 50, 'Mireia Vzquez', 'Plaa  Nobiliari groc 76, 4', 'Esplugas de Llobregat', RSP);
-- Modificaci Client amb comercial donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_CLIENT(305, 10, 51, 'Mnica Vzquez', 'Plaa  Nobiliari groc 76, 4', 'Esplugas de Llobregat', RSP);

/***********************************************************/
/*         7- Test taula PROCESCAPTACIO          */
/***********************************************************/
-- Alta procs de captaci amb dades correctes - OK
PROC_A_PROCESCAPTACIO('Xarxes socials','01/01/2016',RSP);
PROC_A_PROCESCAPTACIO('Anunci rdio','01/01/2016',RSP);
PROC_A_PROCESCAPTACIO('Mailing','01/01/2016',RSP);
-- Alta procs de captaci amb dades  NULL no permeses - ERROR CONTROLAT
PROC_A_PROCESCAPTACIO('Mailing',NULL,RSP);
-- Baixa procs de captaci amb dades correctes - OK
PROC_B_PROCESCAPTACIO(8,RSP);
-- Baixa procs de captaci ja donat de baixa- ERROR CONTROLAT
PROC_B_PROCESCAPTACIO(8,RSP);
-- Baixa procs de captaci que no existeix - ERROR CONTROLAT
PROC_B_PROCESCAPTACIO(99,RSP);
-- Baixa procs de captaci amb candidat associat- ERROR CONTROLAT
PROC_B_PROCESCAPTACIO(1,RSP);
-- Modificaci procs de captaci amb dades correctes - OK
PROC_M_PROCESCAPTACIO(7,'Anunci rdio','30/01/2016',RSP);
-- Modificaci procs de captaci ja donat de baixa- ERROR CONTROLAT
PROC_M_PROCESCAPTACIO(8,'Mailing','30/01/2016',RSP);
-- Modificaci procs de captaci que no existeix - ERROR CONTROLAT
PROC_M_PROCESCAPTACIO(99,'Anunci rdio','30/01/2016',RSP);
-- Modificaci procs de captaci amb dades  NULL no permeses - ERROR CONTROLAT
PROC_M_PROCESCAPTACIO(7,NULL,'30/01/2016',RSP);

/***********************************************************/
/*         8- Test taula CANDIDAT                */
/***********************************************************/
-- Alta Candidat amb dades correctes - OK
PROC_A_CANDIDAT(1,6, 21, 'Pau Parera', '01/01/1970','N', RSP);
PROC_A_CANDIDAT(1,6, 21, 'Pere Garcia', '01/01/1971','N', RSP);
PROC_A_CANDIDAT(1,6, 21, 'Pau Ramos', '01/01/1972','N', RSP);
PROC_A_CANDIDAT(1,6, 21, 'Pere Gonzlez', '01/01/1973','N', RSP);
PROC_A_CANDIDAT(1,6, 21, 'Pau Rodrguez', '01/01/1974','N', RSP);
-- Alta Candidat amb dades a NULL no permeses - ERROR CONTROLAT
PROC_A_CANDIDAT(1, 6, 21, NULL, '01/01/1974','N', RSP);
-- Alta Candidat amb dades al camp Mobilitat no permeses- ERROR CONTROLAT
PROC_A_CANDIDAT(1, 6, 21, 'Pau Rodrguez', '01/01/1974','X', RSP);
-- Alta Candidat amb seu associada donada de baixa o que no existeix- ERROR CONTROLAT
PROC_A_CANDIDAT(999, 6, 21, 'Pau Rodrguez', '01/01/1974','N', RSP);
-- Alta Candidat amb procs de captaci donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_CANDIDAT(1, 999, 21, 'Pau Rodrguez', '01/01/1974','N', RSP);
-- Alta Candidat amb nivell d'estudis donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_CANDIDAT(1,6, 999, 'Pau Parera', '01/01/1970','N', RSP);
-- Baixa Candidat amb dades correctes - OK
PROC_B_CANDIDAT(1001, RSP);
-- Baixa Candidat ja donat de baixa - ERROR CONTROLAT
PROC_B_CANDIDAT(1001, RSP);
-- Baixa Candidat que no existeix - ERROR CONTROLAT
PROC_B_CANDIDAT(9999, RSP);
-- Baixa Candidat amb entrevistes, processos o competncies associades - ERROR CONTROLAT
PROC_B_CANDIDAT(1, RSP);
-- Baixa Candidat amb entrevistes, processos o competncies associades - ERROR CONTROLAT
PROC_B_CANDIDAT(2,RSP);
-- Baixa Candidat amb entrevistes, processos o competncies associades - ERROR CONTROLAT
PROC_B_CANDIDAT(3,RSP);
-- Baixa Candidat amb entrevistes, processos o competncies associades - ERROR CONTROLAT
PROC_B_CANDIDAT(4,RSP);
-- Modificaci Candidat amb dades correctes - OK
PROC_M_CANDIDAT(1002,1,6, 21, 'Pere Garcia', '01/01/1971','N', RSP);
-- Modificaci Candidat ja donat de baixa - ERROR CONTROLAT
PROC_M_CANDIDAT(1001,1,6, 21, 'Pere Garcia', '01/01/1971','N', RSP);
-- Modificaci Candidat que no existeix - ERROR CONTROLAT
PROC_M_CANDIDAT(9999,1,6, 21, 'Pere Garcia', '01/01/1971','N', RSP);
-- Modificaci Candidat amb dades a NULL no permeses - ERROR CONTROLAT
PROC_M_CANDIDAT(1002,1,6, 21, NULL, '01/01/1971','N', RSP);
-- Modificaci Candidat amb seu associada donada de baixa o que no existeix- ERROR CONTROLAT
PROC_M_CANDIDAT(1002,NULL,6, 21, 'Pere Garcia', '01/01/1971','N', RSP);
-- Modificaci Candidat amb procs de captaci donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_CANDIDAT(1002,1,NULL, 21, 'Pere Garcia', '01/01/1971','N', RSP);
-- Modificaci Candidat amb nivell d'estudis donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_CANDIDAT(1002,1,6, NULL, 'Pere Garcia', '01/01/1971','N', RSP);

/***********************************************************/
/*         9- Test taula ENTREVISTAINTERNA       */
/***********************************************************/
PROC_A_ENTREVISTAINTERNA(7,1000,'09/03/2015', 'P',RSP);
PROC_A_ENTREVISTAINTERNA(11,1002,'09/03/2015', 'P',RSP);
PROC_A_ENTREVISTAINTERNA(12,1003,'09/03/2016', 'P',RSP);
PROC_A_ENTREVISTAINTERNA(13,1004,'09/03/2016', 'P',RSP);
PROC_A_ENTREVISTAINTERNA(14,1005,'09/03/2016', 'P',RSP);
-- Alta EntrevistaInterna amb dades a NULL no permeses - ERROR CONTROLAT
PROC_A_ENTREVISTAINTERNA(14,1005,NULL, 'P',RSP);
-- Alta EntrevistaInterna amb dades al camp Resultat no permeses - ERROR CONTROLAT
PROC_A_ENTREVISTAINTERNA(14,1005,'09/03/2016', 'X',RSP);
-- Alta EntrevistaInterna amb seu donada de baixa o que no existeix- ERROR CONTROLAT
PROC_A_ENTREVISTAINTERNA(15,1000,'09/03/2015', 'P',RSP);
-- Alta EntrevistaInterna amb candidat donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_ENTREVISTAINTERNA(7,9999,'09/03/2015', 'P',RSP);
-- Baixa EntrevistaInterna amb dades correctes - OK
PROC_B_ENTREVISTAINTERNA(901, RSP);
-- Baixa EntrevistaInterna ja donada de baixa - ERROR CONTROLAT
PROC_B_ENTREVISTAINTERNA(901, RSP);
-- Baixa EntrevistaInterna que no existeix - ERROR CONTROLAT
PROC_B_ENTREVISTAINTERNA(9999, RSP);
-- Modificaci EntrevistaInterna amb dades correctes - OK
PROC_M_ENTREVISTAINTERNA(902,11,1002,'30/03/2015', 'P',RSP);
-- Modificaci EntrevistaInterna ja donada de baixa - ERROR CONTROLAT
PROC_M_ENTREVISTAINTERNA(901,11,1002,'30/03/2016', 'P',RSP);
-- Modificaci EntrevistaInterna que no existeix - ERROR CONTROLAT
PROC_M_ENTREVISTAINTERNA(9999,11,1002,'30/03/2016', 'P',RSP);
-- Modificaci EntrevistaInterna amb dades a NULL no permeses - ERROR CONTROLAT
PROC_M_ENTREVISTAINTERNA(902,11,1002,NULL, 'P',RSP);
-- Modificaci EntrevistaInterna amb dades al camp Resultat no permeses - ERROR CONTROLAT
PROC_M_ENTREVISTAINTERNA(902,11,1002,'30/03/2016', 'X',RSP);
-- Modificaci EntrevistaInterna amb seu donada de baixa o que no existeix- ERROR CONTROLAT
PROC_M_ENTREVISTAINTERNA(902,15,1002,'30/03/2016', 'P',RSP);
-- Modificaci EntrevistaInterna amb candidat donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_ENTREVISTAINTERNA(902,11,9999,'30/03/2016', 'P',RSP);

/***********************************************************/
/*         10- Test taula PROCESSELECCIO         */
/***********************************************************/
-- Alta ProcesSelecci amb dades correctes - OK
PROC_A_PROCESSELECCIO(302, 21, '01/03/2015',NULL,'P',RSP);
PROC_A_PROCESSELECCIO(302, 21, '01/04/2015',NULL,'P',RSP);
PROC_A_PROCESSELECCIO(302, 21, '01/05/2015',NULL,'P',RSP);
PROC_A_PROCESSELECCIO(302, 21, '01/06/2015',NULL,'P',RSP);
PROC_A_PROCESSELECCIO(302, 21, '01/07/2015',NULL,'P',RSP);
-- Alta ProcesSelecci amb dades a NULL no permeses - ERROR CONTROLAT
PROC_A_PROCESSELECCIO(302, 21, NULL,NULL,'P',RSP);
-- Alta ProcesSelecci amb dades en el camp Resultat no permeses - ERROR CONTROLAT
PROC_A_PROCESSELECCIO(302, 21, '01/07/2015',NULL,'X',RSP);
-- Alta ProcesSelecci amb client associat donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_PROCESSELECCIO(9999, 21, '01/07/2015',NULL,'P',RSP);
-- Alta ProcesSelecci amb nivell d'estudis associat donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_PROCESSELECCIO(302, 999, '01/07/2015',NULL,'P',RSP);
-- Baixa ProcesSelecci amb dades correctes - OK
PROC_B_PROCESSELECCIO(101,RSP);
-- Baixa ProcesSelecci ja donat de baixa - ERROR CONTROLAT
PROC_B_PROCESSELECCIO(101,RSP);
-- Baixa ProcesSelecci que no existeix - ERROR CONTROLAT
PROC_B_PROCESSELECCIO(999,RSP);
-- Modificaci ProcesSelecci amb dades correctes - OK
PROC_M_PROCESSELECCIO(102,302, 21, '30/04/2015',NULL,'P',RSP);
-- Modificaci ProcesSelecci ja donat de baixa - ERROR CONTROLAT
PROC_M_PROCESSELECCIO(101,302, 21, '30/04/2015',NULL,'P',RSP);
-- Modificaci ProcesSelecci que no existeix - ERROR CONTROLAT
PROC_M_PROCESSELECCIO(9999,302, 21, '30/04/2015',NULL,'P',RSP);
-- Modificaci ProcesSelecci amb dades a NULL no permeses - ERROR CONTROLAT
PROC_M_PROCESSELECCIO(102,302, 21, NULL,NULL,'P',RSP);
-- Modificaci ProcesSelecci amb dades en el camp Resultat no permeses - ERROR CONTROLAT
PROC_M_PROCESSELECCIO(102,302, 21, '30/04/2015',NULL,'X',RSP);
-- Modificaci ProcesSelecci amb client associat donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_PROCESSELECCIO(102,9999, 21, '30/04/2015',NULL,'P',RSP);
-- Modificaci ProcesSelecci amb nivell d'estudis associat donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_PROCESSELECCIO(102,302, 999, '30/04/2015',NULL,'P',RSP);

/***********************************************************/
/*         11- Test taula ENTREVISTAEXTERNA      */
/***********************************************************/
-- Alta EntrevistaExterna amb dades correctes - OK
PROC_A_ENTREVISTAEXTERNA(102, 1002, 102, '01/04/2016', 'P', RSP);
PROC_A_ENTREVISTAEXTERNA(102, 1003, 103, '01/05/2016', 'P', RSP);
PROC_A_ENTREVISTAEXTERNA(102, 1004, 104, '01/06/2016', 'P', RSP);
PROC_A_ENTREVISTAEXTERNA(102, 1005, 105, '01/07/2016', 'P', RSP);
PROC_A_ENTREVISTAEXTERNA(102, 1000, 100, '01/08/2016', 'P', RSP);
-- Alta EntrevistaExterna amb dades  NULL no permeses - ERROR CONTROLAT
PROC_A_ENTREVISTAEXTERNA(102, 1002, 102, NULL, 'P', RSP);
-- Alta EntrevistaExterna amb camp Resultat amb dades no permeses - ERROR CONTROLAT
PROC_A_ENTREVISTAEXTERNA(102, 1002, 102, '01/04/2016', 'X', RSP);
-- Alta EntrevistaExterna amb client, candidat o proces de selecci donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_ENTREVISTAEXTERNA(999, 1002, 102, '01/04/2016', 'P', RSP);
-- Alta EntrevistaExterna amb client, candidat o proces de selecci donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_ENTREVISTAEXTERNA(102, 9999, 102, '01/04/2016', 'P', RSP);
-- Alta EntrevistaExterna amb client, candidat o proces de selecci donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_ENTREVISTAEXTERNA(102, 1002, 999, '01/04/2016', 'P', RSP);
-- Baixa EntrevistaExterna amb dades correctes - OK
PROC_B_ENTREVISTAEXTERNA(301,RSP);
-- Baixa EntrevistaExterna ja donada de baixa- ERROR CONTROLAT
PROC_B_ENTREVISTAEXTERNA(301,RSP);
-- Baixa EntrevistaExterna que no existeix- ERROR CONTROLAT
PROC_B_ENTREVISTAEXTERNA(999,RSP);
-- Modificaci EntrevistaExterna amb dades correctes - OK
PROC_M_ENTREVISTAEXTERNA(302,102, 1003, 103, '30/05/2016', 'P', RSP);
-- Modificaci EntrevistaExterna ja donada de baixa- ERROR CONTROLAT
PROC_M_ENTREVISTAEXTERNA(301,102, 1003, 103, '30/05/2016', 'P', RSP);
-- Modificaci EntrevistaExterna que no existeix- ERROR CONTROLAT
PROC_M_ENTREVISTAEXTERNA(999,102, 1003, 103, '30/05/2016', 'P', RSP);
-- Modificaci EntrevistaExterna amb dades  NULL no permeses - ERROR CONTROLAT
PROC_M_ENTREVISTAEXTERNA(302,102, 1003, 103, NULL, 'P', RSP);
-- Modificaci EntrevistaExterna amb camp Resultat amb dades no permeses - ERROR CONTROLAT
PROC_M_ENTREVISTAEXTERNA(302,102, 1003, 103, '30/05/2016', 'X', RSP);
-- Modificaci EntrevistaExterna amb client, candidat o proces de selecci donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_ENTREVISTAEXTERNA(302,999, 1003, 103, '30/05/2016', 'P', RSP);
-- Modificaci EntrevistaExterna amb client, candidat o proces de selecci donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_ENTREVISTAEXTERNA(302,102, 9999, 103, '30/05/2016', 'P', RSP);
-- Modificaci EntrevistaExterna amb client, candidat o proces de selecci donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_ENTREVISTAEXTERNA(302,102, 1003, 999, '30/05/2016', 'P', RSP);

/***********************************************************/
/*         12- Test taula VISITACOMERCIAL        */
/***********************************************************/
-- Alta VisitaComercial amb dades correctes - OK
PROC_A_VISITACOMERCIAL(52, 302, '01/01/2016',RSP);
PROC_A_VISITACOMERCIAL(52, 303, '01/02/2016',RSP);
PROC_A_VISITACOMERCIAL(52, 304, '01/03/2016',RSP);
PROC_A_VISITACOMERCIAL(52, 305, '01/04/2016',RSP);
PROC_A_VISITACOMERCIAL(52, 302, '01/05/2016',RSP);
PROC_A_VISITACOMERCIAL(52, 303, '01/06/2016',RSP);
-- Alta VisitaComercial amb dades a NULL no permeses - ERROR CONTROLAT
PROC_A_VISITACOMERCIAL(52, 303, NULL,RSP);
-- Alta VisitaComercial amb comercial o client donat de baiXa o que no existeix- ERROR CONTROLAT
PROC_A_VISITACOMERCIAL(99, 303, '01/06/2016',RSP);
-- Alta VisitaComercial amb comercial o client donat de baica o que no existeix- ERROR CONTROLAT
PROC_A_VISITACOMERCIAL(52, 999, '01/06/2016',RSP);
-- Baixa VisitaComercial amb dades correctes - OK
PROC_B_VISITACOMERCIAL(601,RSP);
-- Baixa VisitaComercial ja donada de baixa- ERROR CONTROLAT
PROC_B_VISITACOMERCIAL(601,RSP);
-- Baixa VisitaComercial que no existeix- ERROR CONTROLAT
PROC_B_VISITACOMERCIAL(999,RSP);
-- Modificaci VisitaComercial amb dades correctes - OK
PROC_M_VISITACOMERCIAL(602,52, 303, '28/02/2016',RSP);
-- Modificaci VisitaComercial ja donada de baixa- ERROR CONTROLAT
PROC_M_VISITACOMERCIAL(601,52, 303, '28/02/2016',RSP);
-- Modificaci VisitaComercial que no existeix- ERROR CONTROLAT
PROC_M_VISITACOMERCIAL(999,52, 303, '28/02/2016',RSP);
-- Modificaci VisitaComercial amb dades a NULL no permeses - ERROR CONTROLAT
PROC_M_VISITACOMERCIAL(602,52, 303, NULL,RSP);
-- Modificaci VisitaComercial amb comercial o client donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_VISITACOMERCIAL(602,99, 303, '28/02/2016',RSP);
-- Modificaci VisitaComercial amb comercial o client donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_VISITACOMERCIAL(602,52, 999, '28/02/2016',RSP);


/***********************************************************/
/*         13- Test taula PROPOSTACOMERCIAL      */
/***********************************************************/
-- Alta PropostaComercial amb dades correctes - OK
PROC_A_PROPOSTACOMERCIAL(53,303,1500, '01/01/2015', 'R',RSP);
PROC_A_PROPOSTACOMERCIAL(53,303,1300, '01/02/2015', 'R',RSP);
PROC_A_PROPOSTACOMERCIAL(53,303,1100, '01/02/2015', 'R',RSP);
PROC_A_PROPOSTACOMERCIAL(53,303,1100, '01/02/2015', 'R',RSP);
PROC_A_PROPOSTACOMERCIAL(29,304,1500, '01/01/2015', 'A',RSP);
PROC_A_PROPOSTACOMERCIAL(29,304,3000, '01/02/2015', 'A',RSP);
PROC_A_PROPOSTACOMERCIAL(29,304,4000, '01/02/2015', 'A',RSP);
-- Alta PropostaComercial amb dades a NULL no permeses - ERROR CONTROLAT
PROC_A_PROPOSTACOMERCIAL(53,303,1500, NULL, 'R',RSP);
-- Alta PropostaComercial amb camp estat amb dades no permeses- ERROR CONTROLAT
PROC_A_PROPOSTACOMERCIAL(53,303,1500, '01/01/2015', 'X',RSP);
-- Alta PropostaComercial amb comercial o client donat de baica o que no existeix- ERROR CONTROLAT
PROC_A_PROPOSTACOMERCIAL(99,303,1500, '01/01/2015', 'R',RSP);
-- Alta PropostaComercial amb comercial o client donat de baica o que no existeix- ERROR CONTROLAT
PROC_A_PROPOSTACOMERCIAL(53,999,1500, '01/01/2015', 'R',RSP);
-- Baixa PropostaComercial amb dades correctes - OK
PROC_B_PROPOSTACOMERCIAL(601,RSP);
-- Baixa PropostaComercial ja donada de baixa- ERROR CONTROLAT
PROC_B_PROPOSTACOMERCIAL(601,RSP);
-- Baixa PropostaComercial que no existeix- ERROR CONTROLAT
PROC_B_PROPOSTACOMERCIAL(999,RSP);
-- Modificaci PropostaComercial amb dades correctes - OK
PROC_M_PROPOSTACOMERCIAL(602,53,303,1350, '01/02/2015', 'R',RSP);
-- Modificaci PropostaComercial ja donada de baixa- ERROR CONTROLAT
PROC_M_PROPOSTACOMERCIAL(601,53,303,1350, '01/02/2015', 'R',RSP);
-- Modificaci PropostaComercial que no existeix- ERROR CONTROLAT
PROC_M_PROPOSTACOMERCIAL(999,53,303,1350, '01/02/2015', 'R',RSP);
-- Modificaci PropostaComercial amb dades a NULL no permeses - ERROR CONTROLAT
PROC_M_PROPOSTACOMERCIAL(602,53,303,1350, NULL, 'R',RSP);
-- Modificaci PropostaComercial amb camp estat amb dades no permeses- ERROR CONTROLAT
PROC_M_PROPOSTACOMERCIAL(602,53,303,1350, '01/02/2015', 'X',RSP);
-- Modificaci PropostaComercial amb comercial o client donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_PROPOSTACOMERCIAL(602,99,303,1350, '01/02/2015', 'R',RSP);
-- Modificaci PropostaComercial amb comercial o client donat de baixa o que no existeix- ERROR CONTROLAT
PROC_M_PROPOSTACOMERCIAL(602,53,999,1350, '01/02/2015', 'R',RSP);


/***********************************************************/
/*         14- Test taula CANDIDATCOMPETENCIA    */
/***********************************************************/
-- Alta CandidatCompetencia amb dades correctes - OK
PROC_A_CANDIDATCOMPETENCIA(1002, 26,RSP);
PROC_A_CANDIDATCOMPETENCIA(1003, 26,RSP);
PROC_A_CANDIDATCOMPETENCIA(1004, 26,RSP);
PROC_A_CANDIDATCOMPETENCIA(1005, 26,RSP);
PROC_A_CANDIDATCOMPETENCIA(1000, 26,RSP);
-- Alta CandidatCompetencia amb dades dades a NULL no permeses - ERROR CONTROLAT
PROC_A_CANDIDATCOMPETENCIA(NULL, 26,RSP);
-- Alta CandidatCompetencia amb candidat o competnica donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_CANDIDATCOMPETENCIA(9999, 26, RSP);
-- Alta CandidatCompetencia amb candidat o competnica donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_CANDIDATCOMPETENCIA(1000, 99,RSP);
-- Alta CandidatCompetencia amb competnica ja assignada al candidat- ERROR CONTROLAT
PROC_A_CANDIDATCOMPETENCIA(1000, 26,RSP);
-- Baixa CandidatCompetencia amb dades correctes - OK
PROC_B_CANDIDATCOMPETENCIA(1002,26, RSP);
-- Baixa CandidatCompetencia amb relaci candidat-competncia ja donada de baixa- ERROR CONTROLAT
PROC_B_CANDIDATCOMPETENCIA(1002,26, RSP);
-- Baixa CandidatCompetencia amb relaci candidat-competncia que no existeix- ERROR CONTROLAT
PROC_B_CANDIDATCOMPETENCIA(1002,20, RSP);

/***********************************************************/
/*         15- Test taula CANDIDATPROCESSEL      */
/***********************************************************/
-- Alta CandidatProcesSel amb dades correctes - OK
PROC_A_CANDIDATPROCESSEL(1, 1,RSP);
PROC_A_CANDIDATPROCESSEL(2, 2,RSP);
PROC_A_CANDIDATPROCESSEL(3, 3,RSP);
PROC_A_CANDIDATPROCESSEL(4, 4,RSP);
PROC_A_CANDIDATPROCESSEL(5, 5,RSP);
-- Alta CandidatProcesSel amb dades dades a NULL no permeses - ERROR CONTROLAT
PROC_A_CANDIDATPROCESSEL(NULL, 1,RSP);
-- Alta CandidatProcesSel amb candidat o procs de selecci donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_CANDIDATPROCESSEL(999, 1,RSP);
-- Alta CandidatProcesSel amb candidat o procs de selecci donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_CANDIDATPROCESSEL(1, 9999,RSP);
-- Alta CandidatProcesSel amb candidat ja assignat al procs de selecci- ERROR CONTROLAT
PROC_A_CANDIDATPROCESSEL(2, 2,RSP);
-- Baixa CandidatProcesSel amb dades correctes - OK
PROC_B_CANDIDATPROCESSEL(1, 1,RSP);
-- Baixa CandidatProcesSel amb relaci candidat-processel ja donada de baixa- ERROR CONTROLAT
PROC_B_CANDIDATPROCESSEL(1, 1,RSP);
-- Baixa CandidatProcesSel amb relaci candidat-processel que no existeix- ERROR CONTROLAT
PROC_B_CANDIDATPROCESSEL(1002, 1,RSP);


/***********************************************************/
/*         16- Test taula PROCESSELCOMPETENCIA   */
/***********************************************************/
-- Alta ProcesSelCompetencia amb dades correctes - OK
PROC_A_PROCESSELCOMPETENCIA (7,18,RSP);
PROC_A_PROCESSELCOMPETENCIA (8,8,RSP);
PROC_A_PROCESSELCOMPETENCIA (11,8,RSP);
PROC_A_PROCESSELCOMPETENCIA (12,8,RSP);
PROC_A_PROCESSELCOMPETENCIA (14,12,RSP);
PROC_A_PROCESSELCOMPETENCIA (15,12,RSP);
-- Alta ProcesSelCompetencia amb dades dades a NULL no permeses - ERROR CONTROLAT
PROC_A_PROCESSELCOMPETENCIA (NULL,7,RSP);
-- Alta ProcesSelCompetencia amb processel o competncia donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_PROCESSELCOMPETENCIA (999,7,RSP);
-- Alta ProcesSelCompetencia amb processel o competncia donat de baixa o que no existeix- ERROR CONTROLAT
PROC_A_PROCESSELCOMPETENCIA (8,9999,RSP);
-- Alta ProcesSelCompetencia amb competncia ja assignada al procs de selecci- ERROR CONTROLAT
PROC_A_PROCESSELCOMPETENCIA (7,18,RSP);
-- Baixa ProcesSelCompetencia amb dades correctes - OK
PROC_B_PROCESSELCOMPETENCIA (15,12,RSP);
-- Baixa ProcesSelCompetencia amb relaci processel-competncia ja donada de baixa- ERROR CONTROLAT
PROC_B_PROCESSELCOMPETENCIA (15,12,RSP);
-- Baixa ProcesSelCompetencia amb relaci processel-competncia que no existeix- ERROR CONTROLAT
PROC_B_PROCESSELCOMPETENCIA (13,6,RSP);

END;
/



