/* IMPORTANT: s necessari estar connectat amb l'usuari ECOLLADOF amb password 12345678 abans d'executar aquest script       */
/* En aquest script es realitzen s'executen els procediments de consulta al magatzem de dades per a cadascuna                */
/* de les consultes demanades pel client i, per testejar que el magatzem de dades t la informaci correta, es generen       */
/* les mateixes consultes fent SELECT nica i exclisivament a les taules de la base de dades operacional.                    */
/* Per als casos d's que han de mostrar un any concret s'ha escollit l'any 2015. Tots les resultats es mostren per pantalla */

SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('-------------------------------------------------------------------------------'); 
  dbms_output.put_line('TEST MAGATZEM DE DADES'); 
  dbms_output.put_line('Per a cada cas d''s executem el procediment a cost 1 a la taula del DW i per '); 
  dbms_output.put_line('comprovar que estan ben calculades fem SELECT directament a les taules de la BD'); 
  dbms_output.put_line('-------------------------------------------------------------------------------'); 
END;
/

/***********************************************************/
/*         CU15- Test DWNUMENTI                            */
/*                                                         */
/* Nmero d'entrevistes realitzades internament a candidats*/
/***********************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU15');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU15----');
  PROC_CU15(2015, RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULES BD----');
END;
/ 
SELECT EXTRACT (YEAR FROM DATA) AS anyo, COUNT (*) AS num_ent  FROM ENTREVISTAINTERNA 
  WHERE DATABAIXA IS NULL AND EXTRACT (YEAR FROM DATA)=2015 GROUP BY EXTRACT (YEAR FROM DATA);

/*************************************************************/
/*         CU16- Test DWPROCSELPOSITIUS                      */
/*                                                           */
/* Percentatge de processos de selecci positius donat un any*/
/*************************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
   num_pro  Integer;
   num_pos  Integer;
   percentatge  Float;
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU16');
  dbms_output.put_line('*****************************************************************************'); 
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU16----');
  PROC_CU16(2015, RSP);  
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULES BD----');
END;
/ 
SELECT EXTRACT (YEAR FROM DATAINICI) AS anyo, 
((SELECT round((num_pos*100)/num_pro,7) FROM 
  (SELECT COUNT(IDPROCESSEL) AS num_pro FROM PROCESSELECCIO WHERE DATABAIXA IS NULL AND EXTRACT (YEAR FROM DATAINICI)=2015),
  (SELECT COUNT(IDPROCESSEL) AS num_pos FROM PROCESSELECCIO WHERE DATABAIXA IS NULL AND RESULTAT='P' AND EXTRACT (YEAR FROM DATAINICI)=2015))) 
  AS perc_positius FROM PROCESSELECCIO 
  WHERE EXTRACT (YEAR FROM DATAINICI)=2015 GROUP BY EXTRACT (YEAR FROM DATAINICI);

/***********************************************************/
/*         CU17- Test DWTOTCANDIDATS                          */
/*                                                         */
/* Percentatge candidats no seleccionats en cap procs de selecci*/
/***********************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
   no_seleccionats  Integer;
   total_candidats  Integer;
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU17');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('----RESULTAT EXECUTANT PROC_CU17----');
  PROC_CU17(RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULA BD----');
END;
/ 
SELECT round((no_seleccionats*100)/total_candidats,4) AS perc_no_seleccionats FROM 
(SELECT COUNT(IDCANDIDAT) AS no_seleccionats FROM CANDIDAT WHERE NUMPROCESSEL=0 AND DATABAIXA IS NULL),
(SELECT COUNT(IDCANDIDAT) AS total_candidats FROM CANDIDAT WHERE DATABAIXA IS NULL);

/***********************************************************/
/*         CU18- Test DWIMPORTPROPACC                           */
/*                                                         */
/* Import de les propostes comercials acceptades en un any*/
/***********************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU18');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('----RESULTAT EXECUTANT PROC_CU18----');
  PROC_CU18(2015, RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULA BD----');
END;
/ 
  
  SELECT EXTRACT(YEAR FROM DATAPROPOSTA) AS anyo, SUM(IMPORT) AS import_acceptades 
 FROM PROPOSTACOMERCIAL  
   WHERE EXTRACT(YEAR FROM DATAPROPOSTA)=2015 AND ESTAT='A' AND DATABAIXA IS NULL
 GROUP BY EXTRACT(YEAR FROM DATAPROPOSTA);

/****************************************************************/
/*         CU19- Test DWCOMMILLORRATIO                            */
/*                                                              */
/* Comercial que t millor rtio                 */
/****************************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU19');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU19----');
  PROC_CU19(RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULA BD----');
END;
/ 
SELECT NOM, RATIO FROM (SELECT NOM, RATIO FROM COMERCIAL ORDER BY RATIO DESC, NOM) WHERE rownum = 1;

/****************************************************************/
/*         CU20- Test DWMILLORPROCCAP                            */
/*                                                              */
/* Procs de captaci amb ms candidats seleccionats en processos de selecci                 */
/****************************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU20');
  dbms_output.put_line('*****************************************************************************'); 
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU20----');
  PROC_CU20(RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULA BD----');
END;
/ 
SELECT * FROM (SELECT P.TIPUS, COUNT (P.TIPUS) FROM PROCESCAPTACIO P 
  INNER JOIN CANDIDAT C ON (P.IDPROCESCAP=C.FIDPROCESCAP) INNER JOIN CANDIDATPROCESSEL S 
   ON (C.IDCANDIDAT= S.FIDCANDIDAT) WHERE S.DATABAIXA IS NULL GROUP BY P.TIPUS   ORDER BY COUNT(P.TIPUS)DESC, P.TIPUS) WHERE ROWNUM=1;

/****************************************************************/
/*         CU21- Test DWTOP10ESTUDIS                            */
/*                                                              */
/* Top 10 estudis ms demanats en processos de selecci         */
/****************************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU21');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU21----');
  PROC_CU21(2015, RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULES BD----');
END;
/ 
CREATE OR REPLACE VIEW Top10_Estudis(total, descrip) AS
(SELECT  COUNT(*), E.DESCRIPCIO
FROM PROCESSELECCIO P, NIVELLESTUDIS E
WHERE P.FIDESTUDIS=E.IDESTUDIS AND EXTRACT(YEAR FROM P.DATAINICI)=2015 AND P.DATABAIXA IS NULL
GROUP BY E.DESCRIPCIO);
SELECT * FROM (SELECT * FROM Top10_Estudis ORDER BY TOTAL DESC, DESCRIP) WHERE rownum <= 10;

/****************************************************************/
/*         CU22- Test DWTOP5COMPETENCIA                             */
/*                                                              */
/* Top 5 competncies ms demanades en processos de selecci     */
/****************************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU22');
  dbms_output.put_line('*****************************************************************************'); 
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU22----');
  PROC_CU22(2015, RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULES BD----');
END;
/
CREATE OR REPLACE VIEW Top5_Comp(total, descrip) AS
(SELECT  COUNT(*), C.DESCRIPCIO 
FROM PROCESSELECCIO P, COMPETENCIAPROFESSIONAL C, PROCESSELCOMPETENCIA S
WHERE S.FIDCOMPETENCIA=C.IDCOMPETENCIA AND S.FIDPROCESSEL=P.IDPROCESSEL AND EXTRACT(YEAR FROM P.DATAINICI)=2015 AND S.DATABAIXA IS NULL
GROUP BY C.DESCRIPCIO);
SELECT * FROM (SELECT * FROM Top5_Comp ORDER BY TOTAL DESC, DESCRIP) WHERE rownum <= 5;
/ 

/****************************************************************/
/*         CU23- Test DWCLIENTMESACC                             */
/*                                                              */
/* Client que ms candidats ens ha acceptat           */
/****************************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU23');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU23----');
  PROC_CU23(RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULES BD----');
END;
/ 
SELECT NOM, NUMCANDACCEPTATS FROM (SELECT NOM, NUMCANDACCEPTATS FROM CLIENT ORDER BY NUMCANDACCEPTATS DESC, NOM) WHERE rownum = 1;

/****************************************************************/
/*         CU24- Test DWTOPDENEGCLIENT                             */
/*                                                              */
/* Client que ms propostes comercials ens ha denegat          */
/****************************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU24');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU24----');
  PROC_CU24(2015,RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULES BD----');
END;
/ 
CREATE OR REPLACE VIEW Top_Cli(total, nom) AS
(SELECT  COUNT(*), C.NOM 
FROM PROPOSTACOMERCIAL P, CLIENT C
WHERE P.FIDCLIENT=C.IDCLIENT AND EXTRACT(YEAR FROM P.DATAPROPOSTA)=2015 AND P.DATABAIXA IS NULL AND P.ESTAT='R'
GROUP BY C.NOM);
SELECT * FROM (SELECT * FROM Top_Cli ORDER BY TOTAL DESC, NOM) WHERE rownum <= 1;

/***********************************************************/
/*         CU25- Test DWTOTCANDIDATS                          */
/*                                                         */
/* Percentatge candidats no seleccionats per cap client*/
/***********************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
   no_seleccionats  Integer;
   total_candidats  Integer;
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU25');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('----RESULTAT EXECUTANT PROC_CU25----');
  PROC_CU25(RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULES BD----');
END;
/ 
SELECT round((no_seleccionats*100)/total_candidats,8) FROM 
(SELECT COUNT(IDCANDIDAT) AS no_seleccionats FROM CANDIDAT WHERE SELCLIENT!='S' AND DATABAIXA IS NULL),
(SELECT COUNT(IDCANDIDAT) AS total_candidats FROM CANDIDAT WHERE DATABAIXA IS NULL);

/****************************************************************/
/*         CU26- Test DWVISITCOMERCIAL                            */
/*                                                              */
/* Comercial que ms visites ha realitzat en l'any en curs*/
/****************************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU26');
  dbms_output.put_line('*****************************************************************************');  
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU26----');
  PROC_CU26(RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULES BD----');
END;
/ 
SELECT * FROM (SELECT C.NOM, COUNT (C.NOM) FROM COMERCIAL C INNER JOIN VISITACOMERCIAL V ON (C.IDCOMERCIAL=V.FIDCOMERCIAL) 
WHERE EXTRACT(YEAR FROM V.DATAVISITA)=2016 AND V.DATABAIXA IS NULL GROUP BY C.NOM ORDER BY COUNT(C.NOM)DESC, C.NOM)WHERE ROWNUM=1 ;

/****************************************************************/
/*         CU27- Test DWCAPCANDCLIENTS                             */
/*                                                              */
/* Procs de captaci que ms candidats ens han selecionat els clients*/
/****************************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU27');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU27----');
  PROC_CU27(RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULES BD----');
END;
/ 
SELECT * FROM (SELECT P.TIPUS, COUNT (P.TIPUS) FROM PROCESCAPTACIO P INNER JOIN CANDIDAT C ON (P.IDPROCESCAP=C.FIDPROCESCAP)
INNER JOIN ENTREVISTAEXTERNA E ON (C.IDCANDIDAT=E.FIDCANDIDAT) WHERE E.RESULTAT='P' AND EXTRACT(YEAR FROM E.DATA)=2016
GROUP BY P.TIPUS  ORDER BY COUNT(P.TIPUS)DESC, P.TIPUS) WHERE ROWNUM=1;

/****************************************************************/
/*         CU28- Test DWMENYSENTSEU                             */
/*                                                              */
/* Seu que ha realtzat menys entrevistes internes en l'any actual*/
/****************************************************************/
SET SERVEROUTPUT ON SIZE 100000;
DECLARE
   RSP Varchar2(150);
BEGIN
  dbms_output.put_line('*');
  dbms_output.put_line('*****************************************************************************');
  dbms_output.put_line('CU28');
  dbms_output.put_line('*****************************************************************************'); 
  dbms_output.put_line('----RESULTAT EXECUTANT PRO_CU28----');
  PROC_CU28(RSP);
  dbms_output.put_line('*');
  dbms_output.put_line('----RESULTAT AMB SELECT A TAULES BD----');
END;
/ 
SELECT * FROM (SELECT E.FIDSEU AS SEU, COUNT(E.FIDSEU) AS NumEntAnyActual FROM ENTREVISTAINTERNA E WHERE EXTRACT(YEAR FROM E.DATA)=EXTRACT(YEAR FROM SYSDATE) GROUP BY E.FIDSEU ORDER BY COUNT(E.FIDSEU), FIDSEU)WHERE ROWNUM=1 ;
COMMIT;